SystemOrganization addCategory: #'CodeTalk-Core'!
SystemOrganization addCategory: #'CodeTalk-Editor'!
SystemOrganization addCategory: #'CodeTalk-OB-Commands'!
SystemOrganization addCategory: #'CodeTalk-OB-Lists'!
SystemOrganization addCategory: #'CodeTalk-OB-Nodes'!
SystemOrganization addCategory: #'CodeTalk-Tests'!
SystemOrganization addCategory: #'CodeTalk-Text'!
SystemOrganization addCategory: #'CodeTalk-Text-Attributes'!
SystemOrganization addCategory: #'CodeTalk-Text-Icons'!
SystemOrganization addCategory: #'CodeTalk-Events'!
SystemOrganization addCategory: #'CodeTalk-Model'!

ModifiedEvent subclass: #ModifiedMarkupEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Events'!

!ModifiedMarkupEvent class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 19:02:17.062'!
from: oldMarkup to: newMarkup

	^ (self markup: newMarkup) oldItem: oldMarkup! !

!ModifiedMarkupEvent class methodsFor: 'accessing' stamp: 'mt 9/22/2010 21:06:43.437'!
supportedKinds
	"All the kinds of items that this event can take."
	
	^ Array with: self markupKind! !

!NewParagraph methodsFor: '*codetalk' stamp: 'bs 12/15/2009 12:07'!
selectionStart
	^ selectionStart! !

!NewParagraph methodsFor: '*codetalk' stamp: 'bs 12/15/2009 12:07'!
selectionStop
	^ selectionStop! !

TextLink subclass: #CtMethodLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Attributes'!

!CtMethodLink class methodsFor: 'services' stamp: 'mt 6/11/2009 11:02'!
addMethodLinksInto: aText
	"Parse the message and add links to the methods mentioned. This method will modify the attributes of the given text object."

	| rx s links strm |
	rx := '([A-Z]\w*)(\sclass)?>>#?(\w[\w:]*)' asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 2.
				rx subEnd: 4.
				'{1}{2} {3}' format: {
					rx subexpression: 2.
					rx subexpression: 3.
					rx subexpression: 4}}].

	links do: [:link |
		aText
			addAttribute: (CtMethodLink new classAndMethod: link third)
			from: link first + 1
			to: link second].
		
	^ aText! !

!CtMethodLink methodsFor: 'action' stamp: 'bs 10/18/2009 16:16'!
actOnClickFor: aTextMorph

	[OBCodeBrowser defaultBrowserClass
		openOnClass: self theClass
		selector: self selector.
		World displayWorldSafely]
		on: Error
		do: [:e | Transcript show: '[CodeTalk] Method browsing not possible.'; cr].
	^ true! !

!CtMethodLink methodsFor: 'scanning' stamp: 'mt 7/2/2009 21:43'!
emphasizeScanner: scanner

	(self theClass notNil and: [self theClass selectors includes: self selector])
		ifTrue: [super emphasizeScanner: scanner]
		ifFalse: [scanner textColor: Color red]! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:31'!
selector

	^ (classAndMethod findTokens: Character space) last asSymbol! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:32'!
theClass 

	| c |
	c := Smalltalk at: self theClassName asSymbol ifAbsent: [^nil].
	self theClassIsMeta ifTrue: [^c classSide].
	^c! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:31'!
theClassIsMeta

	^ (classAndMethod findTokens: Character space) second = 'class'! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:26'!
theClassName

	^ (classAndMethod findTokens: Character space) first! !

!OBMorphBuilder methodsFor: '*codetalk' stamp: 'mt 5/27/2009 10:06'!
insertMorph: aMorph

	current ifNotNil: 
			[current addMorphBack: aMorph.
			self current: aMorph do: []].
	^ aMorph! !

!OBMorphBuilder methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:24:21.479'!
textarea: aDefinitionPanel 
	"CodeTalk: Store the pluggable textmorph in the definition panel for later access."
	
	| morph |
	morph := self textMorphClass  
		on: aDefinitionPanel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:.
	morph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	current isNil ifFalse: [ current addMorphBack: morph ].
	
	aDefinitionPanel contentMorph: morph.
	
	^ self 
		current: morph
		do: []! !

!OBMethodVersion methodsFor: '*codetalk-override' stamp: 'mt 5/3/2009 09:39'!
source

	| file |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ file nextChunkText makeSelectorBold! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:52'!
ctCommentAddContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGkSURBVDjLrZJPKINhHMd3UsrJ
TcpBDi6UC+3ookQ5OOBAaCh2cFQ40GqTzURTihI54DRp8dqBg3BQw5BtNmxe/4flT9re5+v3
vJvF2l6Kp749Pe/7fj7P7/09jwqA6i9R/ZugVr+cSZmlvFOgEIGSl0xgnVt3IRyRoDSWtn1c
4qakxQW0yKBEJMbw+MpwHWIQnxgCDwxnQQbvHYP7RoLnJirvntrkkuKvghytZU1+eUWg+Mjg
J/j0nuEkBh9dSTgQo4KB+R0uqEgquCD4PBiDbxlc11HYSfBuILUg/gu8fB/t6rmVcEzw4aWE
fYIdAS6IyILe6S0uUCdtIpd8Hbwah1+SxQlNTE91jJHPI5tcPoiLrBsL6BxrQOtQFep0pc/l
XYU9P14kkngugy/onxlF30ITlpwWOEQB5tV21JgLUNKRZVSCTeM2J6/kuV5fFrbuD8N6OCJX
Y7S3wGxv44K3VHAuxUvR8HVldxFszolvvVncs3DB7+67Wpv9Nig0Qy80yrB+pVG5gsTQh7pq
Yz5Mgkbemc98rdiDJBIDJcTLjs0G/vwDCw/6dFwBuzsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:53'!
ctCommentAddIcon
	^ Icons
			at: #'ctCommentAdd'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentAddContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/28/2009 20:12'!
ctCommentContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEvSURBVDjLY/j//z8DJZiBagZE
tO8QAuKlQPwTiP/jwbuAWAWbARtXHrz1//efv//xgS0n74MMuQ3EbHADgBweIP7z99+//x++
/fv/8tO//88+/vv/5P2//w/f/ft/782//7df/f1/5xXE8OoFx0GGmCEbIJcz9QBY8gVQ47MP
//4/Bmp+8Pbf/7tQzddf/P1/9RnEgM5VZ0EGeGM14ClQ86N3UM2v//2/9RKi+QpQ88UnuA2A
ewHk/PtAW++8/vv/JlDzted//18Gar7wBGTAH7ABtYtOgAywxBqIIEOQAcg1Fx7/BRuMFoic
uKLxDyzK5u64Cjfo/ecfYD5Q/DLWaMSGgQrvPH/3FabxOxDXEp0SgYp7Z267AtL4BYgLSUrK
QA1KQHwPiFPolxcGzAAA94sPIr7iagsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 6/6/2009 13:27'!
ctCommentGoContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAlFJREFUeNqMU0toE1EUPTMJ2oQaJcZPaVpiKxUTjHEjBe3C
ReyiGwXxsxKKoIggiAsX7U5UEBEVXCl0URFBsitWKo2/GolU22ipbVPbNGlTwYakTpLp/J53
JhqGaFrvcLnvzZtz7pnz3uMYYzDHhd7WvKRIdklT7D2dsSLWCL7yhahIcLt2Q5TlwpH7Htta
BNzFR21M0yR6FEiKgnpnC+93H0R0dhCjqfcaEW58fTkjVCOwKpqEoO80rzINqqZCA8NCLok9
7gMQpCI/PPcq57/KO2NdWu6fBLpkHZxYmoJMKhRNhqzKWF75iUBDGwS5wEdn3mVP3Xhuxg1Q
nn98pT1OBCIUVcE2RyOBVYMsnZuDs3Y7PiaHML44gdDZYfjqAmV0X3Q22Ds48YxIfdaCIrKe
yE2QC2SgzDW7vGhtOowPibcYmY/hzrEwNtR4MbPE6BcZOCLo2O9BZHxx53Q6F7CGzn0zdoLY
Gl2OmkTkewc43oaxha+4ezwM96ZdpAzQCFyqJRUO+zq9bLFWmlKUGMKTL/HkzCTqHDuoK4zO
KsPvcYWJpnHmx7Kofu4SLKlskTrZqCMrg/4QcCgdPEGUDUz5IJGj+l73PX0TJ9k2eDZzaHbx
aNnKo3Y9B1UFKeLgr7foJmJqPhun70c481EmH5xU7lGeoLTo74L7GtDZ7jXWs8IKQkPTGPiU
/ELTo/o2QidYLU9e74+nM3n2sH+M0bhI2W1e5yovkzlI0a1De92XwqOpPE27qePtv+5CNQIC
N1F5QXmNgA+qXqbVFPxP/BJgAHnqT8NmxeLpAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 6/6/2009 13:27'!
ctCommentGoIcon

	^ Icons
			at: #'ctCommentGo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentGoContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/28/2009 20:12'!
ctCommentIcon

	^ Icons
			at: #'ctComment'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:51'!
ctCommentsContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAG/SURBVDjLjZK9T8JQFMVZTUyc
3IyJg4mDi87+GyYu6qB/gcZdFxkkJM66qJMGSNRBxDzigJMRQ1jQ4EcQ+SgVKB+FtuL13EdJ
xNDq8Ev7Xu85797T51nwhqeAH5w6cAxWwDgReX7jwYfdaCIraroptB7NLlVQrOoiGEsL1G06
GZyxuILicsMUH3VTlOqGKNUMUdTacj+j1Nng0NGAT2WxYosK1bbIVVoiW27J9V8G57WWKVSc
zMV5iK+Tudv1vVh5yXdlLQN+os4AFZss2Ob82CCgQmhYHSnmkzf2b6rIhTAaaT2aXZALIRdC
LgRtkA1WfYG4iKcVYX52JIs7EYvFmJ8wGiEXQi6EXAhdyn2MxQaPcg68zIETTvzyLsPzWnwq
ixVbhFwI3RFykes+A9vkIBKX4jCoIxdCLrI4/0OcUXXK4/1dbbDBS088xGGCCzAJCsiF2lan
T8xdKNhHXvRarLFBqmcwCrbAhL32+kP3lHguETKRsNlbqUFPeY2OoikW62DNM+jf2ibzQNN0
g5ALC75AGiT59oIReQ+cDGyTB+TC4jaYGXiRXMTD3AFogVmnOjeDMRAC025duo7wH74BwZ8J
lHrTPLcAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:54'!
ctCommentsIcon
	^ Icons
			at: #'ctComments'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentsContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:52'!
ctCrossContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIhSURBVDjLlZPrThNRFIWJicmJ
z6BWiYbIkYDEG0JbBiitDQgm0PuFXqSAtKXtpE2hNuoPTXwSnwtExd6w0pl2OtPlrphKLSXh
x07OZM769qy19wwAGLhM1ddC184+d18QMzoq3lfsD3LZ7Y3XbE5DL6Atzuyilc5Ciyd7IHVf
gNcDYTQ2tvDr5crn6uLSvX+Av2Lk36FFpSVENDe3OxDZu8apO5rROJDLo30+Nlvj5RnTlVNA
Ks1aCVFr7b4BPn6Cls21AWgEQlz2+Dl1h7IdA+i97A/geP65WhbmrnZZ0GIJpr6OqZqYAd5/
gJpKox4Mg7pD2YoC2b0/54rJQuJZdm6Izcgma4TW1WZ0h+y8BfbyJMwBmSxkjw+VObNanp5h
/adwGhaTXF4NWbLj9gEONyCmUZmd10pGgf1/vwcgOT3tUQE0DdicwIod2EmSbwsKE1P8QoDk
cHPJ5YESjgBJkYQpIEZ2KEB51Y6y3ojvY+P8XEDN7uKS0w0ltA7QGCWHCxSWWpwyaCeLy0Bk
A7UXyyg8fIzDoWHeBaDN4tQdSvAVdU1Aok+nsNTipIEVnkywo/FHatVkBoIhnFisOBoZxcGt
Qd4B0GYJNZsDSiAEadUBCkstPtN3Avs2Msa+Dt9XfxoFSNYF/Bh9gP0bOqHLAm2WUF1YQskw
rVFYPWkf3h1iXwbvqGfFPSGW9Eah8HSS9fuZDnS32f71m8KFY7xs/QZyu6TH2+2+FAAAAABJ
RU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:54'!
ctCrossIcon
	^ Icons
			at: #'ctCross'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCrossContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:52'!
ctDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:54'!
ctDeleteIcon
	^ Icons
			at: #'ctDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctDeleteContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 14:11'!
ctMagnifierContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH5SURBVDjLpZK/a5NhEMe/748k
RqypmqQQgz/oUPUPECpCoEVwyNStIA6COFR33boIjg6mg4uL0k0EO1RFISKImkHQxlbQRAsx
0dgKJm/e53nunnOwViR5leJnuZs+973jHBHB/+D/ah7X2LXWloilyMw5YgtD3CDiBWN4Zno8
bQcJHBFBucauZfsolZDCru0OfFcAAUISrLZDfPzSKxuiibOT+T6JCwDMtrQzYQvZHQ5Cw2h3
GK0OI9AWBzJJZFOxgtJUGpTABQAiLu5OOviuGIEWkBUwC7pasNZj7N2ThNJUjBQY4pznAoEW
sBWwxU+JFXSVRTzmQWvKRR5RG4KVGMgKrAVYflexAAugDCEygdbUCI2F7zobk7FZY76DIDQg
rT9HCwwt1FsBhhIu4p4D3kiS8B0MJz28ftfGSPfl8MPLxbGBAqVpptbslJc+fEPMA7JDPrIp
H3FX8LzaROdrE5O51jalgid3Lh4b6/sDALh6971riErGcFET58gwDPGndG9JT6ReHcwfPorG
ygu8rdxvGxMeP3XtzcofgigWZ0/EtQ7n0/sOTe0/Mo7V5WeoVu61z1yvZzZX+BsnZx9opYLp
evXp7eXKIrL5UWit0n0r/Isb50bjRGreiyWmgs76lfM31y5tSQAAc6czHjONXLi13thygih+
AEq4N6GqMsuhAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 14:11'!
ctMagnifierIcon
	^ Icons
			at: #'ctMagnifier'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMagnifierContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:08:07'!
ctMarkGreenContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAV9JREFUeNqM088rBGEcx/FnxiQr8rstByQOcnKhRBuxV1cX
F3+Vk5urAzkI5eKmhIste5Ef0aJltNYu4/3oMxrTbGPqVdvs8/0+3+/zfMcxhybpaUYnetGG
N7zgQ78r+LQLvVigq4AhTGMSWfgo4xFnOMIt6tEEDrowgSUsYEDVfGlNHZdYwybuowk6MIUV
zKNHFTmx1sawiBO8hglaMY5l5NW/EwuOtjmIHJo8vciq5DkFu6bxE2j9KoZtgox2z+uPtGCr
D/3hIXZjRr15Jv0J11TtIdrdRjGL9gY9m9hNOZqBGxzYBCO6rv/sbnSlD9jGrqszyKT0HQ1+
soGagwtX01WOLUxKYssuKXhDc+C7elmKTFv8xK2aet7COo413j99Bwm7hzv6Gt8r7GMHp/qw
fq+kor5qCnzHs2a+oOqKKrmorzGIJrjGngaoxR4MzhV8p4Dwc67+KTMXmG8BBgAGPmJtGrAs
BgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:17:00'!
ctMarkGreenIcon
	^ Icons
			at: #'ctMarkGreen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMarkGreenContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:19:36'!
ctMarkGreenSmallIcon

	^ Icons
			at: #'ctMarkGreenSmall'
			ifAbsentPut:[ self ctMarkGreenIcon scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:07:07'!
ctMarkRedContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAWRJREFUeNqM01srBGEcx/GZ8dh1yq5DyaF4BQ65kJTkwoV3
IC8PKVx4AXLJhZS9cEHKJmkRNjkudnz/+o2eJoOnPu00M//D/J9nwziOg2oYBj+sBjhdx7qO
UEcN7/bAZQTn0Y1eNCtZETnc4hiXeHWpQKvQhiFMY0qBVq0TBZxiDVuWxKVa7sEI5jGLQd23
BI0qYO+c4wT3zqtsD2awiEm0636g1m19KOEwJlBJEljbY1hQ660IMwZriUdxh32n7H2YU+Ws
4NC736Qh5yNtzwDGNbCsYH/VNMyr5Btb0JERnF52JsrahYtIE37Dyz+DK1jHtp2JyBtO7o8O
LPgGG2JbWY80kIJ+fwuuYhNLOFLXX/tc0BBzejHwfpPrB33zCg7tCKePbr8GGStzXdfmGXtY
xQGe/NaSg/SoKqFajXT2rVIJy9i1o+sHF/knOw1mR2fdujnTjnQpaUmVr9XZd7CtTwEGAH3d
WjFDP6vVAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:16:28'!
ctMarkRedIcon
	^ Icons
			at: #'ctMarkRed'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMarkRedContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:19:09'!
ctMarkRedSmallIcon

	^ Icons
			at: #'ctMarkRedSmall'
			ifAbsentPut:[ self ctMarkRedIcon scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:07:47'!
ctMarkYellowContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAV5JREFUeNqM080rRFEYx/F7596GGBMRC4rsSCklslMk2bK1
9Bf5B6Ts7JTYUPJWiMhKEpKI8Z68zPV99Ls6dGfMqU8z93af5zznOef4uchLGmVoRAfa9O4A
W7jCT1SYEFyNdoxgGM0IsIdJLONJST7cBL6CezGOAdQo2EYXxpDFBR5x7jtLqFLwBIb07I5P
3Cs4h2ssxBWk0YJRzZxJWFpKFWWV7BVvoUq3l30Y1H/fKzwCyVsPU3poQD+aNFOxESd/wVFK
AfVoLbArnrNtcbDNfoaduAJbc2WJwZGaadu5HzrnIfin5HhY89Ywh9NQwRUlrD1S8CamsW19
CFW+bWFdke5b8DM2MIUlLeN79rS6X6gH1rA7rGBGvzdxbyzBO27tUCiZO6sdmEssKnhXpzDv
XqYHrKJbytUPS3iCecziUOf/d4e5C/ZxLTrRo35k9LE1ah3HuoF/rm3kfQkwAMgHVkrmL7Ph
AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:16:44'!
ctMarkYellowIcon
	^ Icons
			at: #'ctMarkYellow'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMarkYellowContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:19:23'!
ctMarkYellowSmallIcon

	^ Icons
			at: #'ctMarkYellowSmall'
			ifAbsentPut:[ self ctMarkYellowIcon scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 19:16'!
ctPaintcanContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJVSURBVDjLlZPbS5NhHMd3tbvy
ov6HIJRuhKAFgRci5GXYVQkG0c6HJGvD1FVMjdxC22wlQ9iG7uBh0rtDmxtb77vFoh2c7KgM
tiGbU9xdgezb3hf0Ii3cxZfngef5fn6H5/ewALD+Vv8Upeh7HfzdM+pb4QwT7PPunOg8M7tl
Ph63JtE/4UM3f7WnLUDL3NE7vgmFKYbeF050Di3dbQvQSrvjzogTIm0Yt0WrePp25VNbAHcg
rLopXMOgyo/uR8v4bAnAbrdLLwSIRCLK1HYaHKEdnQ9MuHZ/Edv5MpYcHljc1K9Fgvo+uxqa
nLYEr5wBhMNhZTqdRr1ex6jOBz8VxzONC+VyGQcHB5g3rcFGZWH+lscrc9ArWdjseqzzXWLM
FEWdmnO5HEwbEYzpvmKZ+IFKpYJSqQS/3w/l+4XmlCXYnHGmMfTBOzyg9lxmkSQ5RpsbjQYK
hQKy2Syz7u/vM0Z6T5+73W44nU7IlOrmS9tPPJn3VfsmXVdZLfKbra0tVKtV7O7uYmdnh8mE
BtCwVCqFRCIBgiCg0Wggk8ko7sdNCMwJ3JogRpgSHA6HOhqN4ujoCIeHh6jVashkMkgmk4jH
4wgEApibm4NUKqVEIhH74awXrfSPbyi+dJ020Wg0vguFQtjb20M+n2eixmIxBqDX6+nIpFAo
ZMb63owHHCXhOvOMWq1W7fF4UCwWQZdFN9RqtdKRSYFAcPonrj/fGPznIKlUKvX6+jrTfZvN
BolEQvL5fPaFJ5GWXC5XGwwGiMViksfjtfcbT9Rq1gCXy/2vmdYfaGviUGKvapgAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 19:16'!
ctPaintcanIcon
	^ Icons
			at: #'ctPaintcan'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctPaintcanContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 1/17/2010 17:32'!
ctPencilExContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAkhJREFUeNqkk8trE1EUxr+ZTGaaMY9iHpMm1ibFaCqUSgM+
KqiIdWFFBFF0paAbN+6K+icYXWipSKWrCkoNVikG3yAUYqBmwGq0j4ipJCXWvGqTpmkyM06m
KIZoCXjgbO49v+87h3sPIUkS/ieoegvjL7ZpClnHbOYbYRQFkWR1s1EtQ3fVLZBPO5ckwYb2
I6dBkCQmRi86svHMTaKeEWR3qdF2CZRuowwzypm4vIAJf59I1gObPP2g9ATioXsoJaeUrASp
olbW7OA3zGRRjPshLjH4zM9Dp7chORfB9guPCLIuOPEAkhAB09ICC0ehHAsqcKXurx3UwCsx
5EkzkjMBSPM0li0R4ldtTQevb7hrYLXlIFKRt2ju7EWRiw7Jng0V30pWCTz3bpE8J25VwbT1
EGJvnoBe5wDbyMHA7WsTRHSXBaCSisDAOaejArv3e/FxbLgK/h7gkU1/gtl9YOHUmfswNe3e
LArEUaEMSs5VgRIrftl1cghNG5xIfQiBf/UOiXQbwiMvEZ0aB9VsDUJYNPh8PhRyCQPNOrfK
7ntL5T9GYEgVfoxdh8euhcTHwA8OIz79FQVuesBgbXfNZcbhf9yLZHES6vVWV7mM46USVp8x
EM5h5lkfNK5uUDvOQ9rkAWuxgHSHuxjW1AFV3EiTSfQcvgqWWoRWWzSqG7QdsshOZRckkYD3
7lPsCQVh1TGgzYaRnivvj43eJgc5u75VQyYAtYh86jJyqYdKx1a7oXUylTu75k+8c43oF0V0
/ute3in+pwADAMMdEiSznbNwAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 1/17/2010 17:32'!
ctPencilExIcon

	^ Icons
			at: #'ctPencilEx'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctPencilExContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/30/2009 15:17'!
ctWorldContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMtSURBVDjLVZNLa1xlAIafc5sz
k8xkMkkm5MKY2EpT2qa2MTVCmoLS2gq6EKooimAW7iQb/0I2bgTRIog0oFW7KQpCS7VqrSmm
JGlSQtswqWlLLmbGmcmcZM6cy/edz00r6bt8eXh4N6+mlGJnxiZHR4APgSNAFjCBKjClInXm
05Gzl3by2mPB2OSoCUwAp1/LHbcziSyO24gbgJAegg2urF8UUsifhZBvfvXK99v/C8YmRy3g
t8G2/cMv517E8Wx8ApYcjZiyKbkRSgQkcFn3rzG9Nn1LhOLYt2/8UNUfLZkYaN0zfLRrkLIM
CHUNIXTqIoZLjLJvU/ASrFQtnko+z2BH38HAD78DMConHh4FPn5nz6vGgqyxTp16JNj2kpR9
C8eD/OoW1VoNO1NCS+d5oW0vV27f2PX11MS8MTR6+JOTXUMHNCPBui5AtdMpk8xsGNQ9ndur
20TxCnbPIn5TnmJUwaxIDrTm9Jn7d1tM4EiuqZs5d41iXGefsZsIwYNCgOfVSXconJbLLEWb
4CuahU2+6HO8d4DQF/0m0NpgNvLAXaPgu6QadrEZpKhUItJZj/aMS1EewvHnsdUWW/+WKG82
kEykCAPRbCqlNE1B4DsocpiW5OJfIVoiyfqSQFdNdGXrpLZGcFZDPKYJg2VQCiGEZkoRlZ3A
6W41mknFn2WlaOKFFrG4Tbw9wb2/S3g3miHySLdbNDd2kzYKVGpVpIiqugjF7P3yQ55pyLFW
mCSyVokZPqHnEoYmsWQGuyWOGdexNIkRFOnqbGN5bRngjh4G4rMLd6+KnmQW012lWrpOJuNj
Ch9LU9i6gRkEZHIrpNv/QK8vcijXz5lfLijgS+PmuYV75+fPDXr1Wt9znfsouy5x+2miuolt
W1iawBJV0o0/wT8lBvbv5WZ+gaWNlasz43MfmQChH777e37uT78eHDx5+BiLBROjqhDaFmGk
Q1KS6+mlr7+XX2evc+nWVB54+4kznfr8pZQIxXkRyhPvDb9vIjtQqgFN12hLO2yUZ/ni8o8S
uAa8NTM+t/GE4HGGx4del0J+IGXUH8ko86iuAneAszPjc9/s5P8DuO6ZcsXuRqAAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/30/2009 15:18'!
ctWorldIcon

	^ Icons
			at: #'ctWorld'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctWorldContents readStream)].! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self version category! !

!OBMethodVersionNode methodsFor: '*codetalk-override' stamp: 'mt 1/18/2010 09:23'!
definition
	^ (OBMethodDefinition source: self source inClass: self theClass)
		callback: [:sel | 
					version selector = sel
						ifTrue: [self class on: version latest]
						ifFalse: [OBMethodNode on: sel inClass: self theClass]]! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 5/27/2009 10:39'!
hasVersions

	^ false! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 9/28/2010 16:26:22.382'!
methodSourceMarkups
	"Use specific hash value to retriever older markups."
	
	^ SystemMarkups
		markupsForClass: self theClass
		selector: self selector
		sourceHash: (SecureHashAlgorithm new hashMessage: self version source asString)! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 1/18/2010 09:21'!
source

	^ self sourceText! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 9/28/2010 15:19:16.275'!
sourceText
	"Style the method version source."
	
	| source |
	source := self version source.
	
	CtSourceTextStyler new
		styleSource: source
		markups: (SystemMarkups
			markupsForClass: self theClass
			selector: self selector
			sourceHash: (SecureHashAlgorithm new hashMessage: source asString))
		inClass: self theClass
		selector: self selector.
	
	^ source! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 1/17/2010 11:38'!
timeStamp

	^ version stamp! !

!SmalltalkImage methodsFor: '*codetalk' stamp: 'mt 9/28/2010 15:01:59.169'!
markups

	^ SystemMarkups! !

AddedEvent subclass: #AddedMarkupEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Events'!

!AddedMarkupEvent class methodsFor: 'accessing' stamp: 'mt 9/22/2010 21:06:24.15'!
supportedKinds
	"All the kinds of items that this event can take."
	
	^ Array with: self markupKind! !

OBLazyListMorph subclass: #CtLazyListMorph
	instanceVariableNames: 'showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Lists'!

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 9/22/2010 15:27:39.396'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds top icon node fontToUse |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	node := listSource model children at: row.
	
	(listSource iconAt: row) ifNotNilDo: 
		[:name |
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + (drawBounds height - icon height // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2].
	
	fontToUse := item isText
		ifTrue: [font emphasized: (item emphasisAt: 1)]
		ifFalse: [font].
	
	canvas
		drawString: item
		in: drawBounds
		font: fontToUse
		color: (item isText ifTrue: [item colorAt: 1] ifFalse: [self colorForRow: row]).
	
	drawBounds := drawBounds left: drawBounds left + (fontToUse widthOfString: item asString).

	(node isKindOf: OBClassNode)
		ifTrue: [ drawBounds := self
			indicateMarkupForClass: node
			on: canvas
			in: drawBounds].

	(node isKindOf: OBMethodNode)
		ifTrue: [
			drawBounds := self
				indicateMarkupFor: node
				on: canvas
				in: drawBounds].

	(node isKindOf: OBMethodNode) "& (row ~= selectedRow)"
		ifTrue: [drawBounds := self
			displayCategoryFor: node
			in: drawBounds
			on: canvas].! !

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 3/18/2010 19:47:42.669'!
displayCategoryFor: aMethodNode in: drawBounds on: aCanvas

	| txt |
	self updateProperties.
	(aMethodNode theClass isNil or: [showCategories not])
		ifTrue: [^ drawBounds].
	
	txt := ' ({1})' format: {aMethodNode categoryText}.
	showCategories ifTrue: [aCanvas
		drawString: txt
		in: drawBounds
		font: font
		color: ((aMethodNode categoryText = 'as yet unclassified')
			ifTrue: [Color red]
			ifFalse: [Color gray])].
		
	^ drawBounds left: drawBounds left + (font widthOfString: txt asString) + 2! !

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 9/28/2010 16:26:56.451'!
indicateMarkupFor: aMethodNode on: aCanvas in: drawBounds

	| icon top newBounds |
	aMethodNode theClass ifNil: [^ drawBounds].
	
	newBounds := drawBounds left: drawBounds left + 4.
	aMethodNode methodSourceMarkups
		do: [ :markup |
			icon := (markup tags includes: #bad)
				ifTrue: [MenuIcons ctMarkRedSmallIcon]
				ifFalse: [(markup tags includes: #comment)
					ifTrue: [MenuIcons ctMarkGreenSmallIcon]
					ifFalse: [MenuIcons ctMarkYellowSmallIcon]].
			top := newBounds top + (newBounds height - icon height // 2) + 1.
			aCanvas translucentImage: icon at: newBounds left @ top.
			newBounds := newBounds left: newBounds left + icon width].
	^ newBounds! !

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 9/28/2010 15:00:36.655'!
indicateMarkupForClass: aClassNode on: aCanvas in: drawBounds

	| icon top newBounds |
	aClassNode theClass ifNil: [^ drawBounds].
	
	newBounds := drawBounds left: drawBounds left + 4.
	(SystemMarkups
		markupsForClass: aClassNode theClass kind: #methodSource)
		do: [ :markup |
			icon := (markup tags includes: #bad)
				ifTrue: [MenuIcons ctMarkRedSmallIcon]
				ifFalse: [(markup tags includes: #comment)
					ifTrue: [MenuIcons ctMarkGreenSmallIcon]
					ifFalse: [MenuIcons ctMarkYellowSmallIcon]].
			top := newBounds top + (newBounds height - icon height // 2) + 1.
			aCanvas translucentImage: icon at: newBounds left @ top.
			newBounds := newBounds left: newBounds left + icon width].
	^ newBounds! !

!CtLazyListMorph methodsFor: 'accessing' stamp: 'mt 9/29/2010 15:04:59.955'!
updateProperties

	showCategories ifNil: [showCategories := CtPreferences showProtocolForMessage].! !

!OBPluggableListMorph methodsFor: '*codetalk-override' stamp: 'mt 4/26/2009 21:32'!
listMorphClass
    ^CtLazyListMorph! !

!OBCmdMultiView methodsFor: '*codetalk-override' stamp: 'mt 3/18/2010 20:07:40.392'!
execute
	"CodeTalk: Add a new menu item for CodeTalk styling. Recover original styler for shout first."
	
	|viewType|
	viewType := OBChoiceRequest
		prompt: nil 
		labels: #('source' 'pretty print' 'decompile' 'byte codes' 'source with markups') 
		values: #(showSource showPrettyPrint showDecompile showByteCodes showMarkups).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: viewType]! !

!OBCmdMultiView methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:04:25.778'!
showMarkups

	self
		styler: CtTextStyler new;
		definition: target definition.! !

!OBCmdMultiView methodsFor: '*codetalk' stamp: 'mt 6/11/2009 18:22'!
styler: styler
	"Proxy: Look for the current pluggable text morph in the definition panel and set the styler."
	
	| panel morph |
	panel := requestor browser definitionPanel. 
	morph := OBPluggableTextMorph allSubInstances
		detect: [:each | each model == panel]
		ifNone: [^ self].
	morph styler: (styler view: morph).! !

OBTextMorphEditorWithShout subclass: #CtEditor
	instanceVariableNames: 'deferredSystemMarkupsMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text'!

!CtEditor class methodsFor: 'initialization' stamp: 'mt 6/23/2009 09:41'!
initializeCmdKeyShortcuts

	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($t asInteger + 1) put: #sAddCodeChat:;
		at: ($r asInteger + 1) put: #sMarkAsBad:.! !

!CtEditor methodsFor: 'editing' stamp: 'mt 9/29/2010 09:57:42.582'!
accept

	| result |
	result := super accept.

	self
		updateRanges;
		processDeferredMarkupMessages;
		restyle.
	
	^ result! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:14'!
addCodeChat

	self tagSelectionWith: #talk.! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:48'!
addComment

	self tagSelectionWith: #comment.! !

!CtEditor methodsFor: 'private' stamp: 'mt 9/27/2010 13:11:45.679'!
addMarkup: aMarkup
	"add the given markup to the text - not the database."
	
	CtSourceTextStyler new
		styleSource: self text
		markup: aMarkup
		inClass: self theClass
		selector: self selector.
	
	"Set dependent for new reference attribute to let iconic buttons work."
	((self text attributesOfKind: CtReferenceAttribute)
		detect: [:attr | attr markup = aMarkup]) addDependent: morph.
		
	morph changed. "force redraw"! !

!CtEditor methodsFor: 'actions' stamp: 'mt 9/29/2010 10:20:41.843'!
changeMarkupTag

	| result |
	result := ListChooser
		chooseItemFrom: SystemMarkups tags
		title: 'Change Markup Tag'.
		
	result ifNil: [^ self].

	self changeTagInSelectionTo: result.! !

!CtEditor methodsFor: 'initialize-release' stamp: 'mt 1/22/2010 13:06:17'!
changeParagraph: aParagraph
	"Add a back reference to the textmorph to the paragraph."

	super changeParagraph: aParagraph.
	(aParagraph isKindOf: CtParagraph) & (morph isKindOf: CtTextMorph)
		ifTrue: [
			aParagraph textMorph: morph.
			morph removeAllMorphs.
			(aParagraph text attributesOfKind: CtReferenceAttribute)
				do: [:attr | attr addDependent: morph]].! !

!CtEditor methodsFor: 'editing' stamp: 'mt 9/27/2010 12:59:40.162'!
changeTagInSelectionTo: aSymbol
	"Used to change the tag (#bad, #talk) )of an attribute in the text."

	| attrs |
	attrs := self text
		attributesOfKind: CtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1.
		
	attrs	do: [:ref |
		ref tag: aSymbol.
		(ref friends
			detect: [:friend | friend isKindOf: CtTextBackgroundColor])
			color: ref color.
		(ref friends
			detect: [:friend | friend isKindOf: CtIconBarAttribute])
			mode: ref tag].
	morph changed.
! !

!CtEditor methodsFor: 'menu messages' stamp: 'mig 5/29/2010 10:49:29.043'!
copySelection
	"A modified copy of ParagraphEditor>>#copySelection:
	Copies only the string instead of the full Text to avoid copying CodeTalk Annotations."

	"Copy the current selection and store it in the paste buffer, unless a caret.  Undoer & Redoer: undoCutCopy"

	self lineSelectAndEmptyCheck: [^ self].

	"Simulate 'substitute: self selection' without locking the controller"
	UndoSelection := self selection asString.
	self undoer: #undoCutCopy: with: self clipboardText.
	UndoInterval := self selectionInterval.
	self clipboardTextPut: UndoSelection! !

!CtEditor methodsFor: 'deferred markups' stamp: 'mt 9/28/2010 17:39:11'!
deferMarkupAdding: aMarkup

	| msg |
	msg := [SystemMarkups addMarkup: aMarkup].
	
	self isInLiveEditMode
		ifTrue: [msg value]
		ifFalse: [deferredSystemMarkupsMessages nextPut: msg].! !

!CtEditor methodsFor: 'deferred markups' stamp: 'mt 9/28/2010 16:58:13.838'!
deferMarkupRemoving: aMarkup

	| msg |
	msg := [SystemMarkups removeMarkup: aMarkup].
	self isInLiveEditMode
		ifTrue: [msg value]
		ifFalse: [deferredSystemMarkupsMessages nextPut: msg].! !

!CtEditor methodsFor: 'deferred markups' stamp: 'mt 9/28/2010 16:53:02.938'!
flushDeferredMarkupMessages

	deferredSystemMarkupsMessages flush.! !

!CtEditor methodsFor: 'initialize-release' stamp: 'mt 9/28/2010 17:10:12.847'!
initialize

	super initialize.
	deferredSystemMarkupsMessages := SharedQueue new.! !

!CtEditor methodsFor: 'testing' stamp: 'mt 1/17/2010 14:53'!
isInLiveEditMode
	"Live edit mode enables the developer to add, edit or delete markups without the need to save the method and create a new version. Once the developer changed something in the method's source, live-edit-mode will be disabled. A save operation will then trigger a new markup version for the method."
	
	^ morph hasUnacceptedEdits not! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:48'!
markAsBad

	self tagSelectionWith: #bad.! !

!CtEditor methodsFor: 'deferred markups' stamp: 'mt 9/28/2010 16:52:45.076'!
processDeferredMarkupMessages

	| msg |
	[(msg := deferredSystemMarkupsMessages nextOrNil) notNil] whileTrue: [
		msg value].! !

!CtEditor methodsFor: 'private' stamp: 'mt 1/17/2010 16:28'!
removeAttribute: aReferenceAttribute

	aReferenceAttribute friends do: [:attr |
		self text removeAttribute: attr].
	self text removeAttribute: aReferenceAttribute.
	
	morph changed. "force redraw"! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:05'!
removeMarkup

	self untagSelection.! !

!CtEditor methodsFor: 'actions' stamp: 'mt 9/28/2010 17:00:18.46'!
removeMarkup: aReferenceAttribute

	self 
		deferMarkupRemoving: aReferenceAttribute markup;
		removeAttribute: aReferenceAttribute.! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:26'!
resizeMarkup

	self resizeTagInSelection.! !

!CtEditor methodsFor: 'editing' stamp: 'mt 9/28/2010 17:00:41.467'!
resizeTagInSelection
	"Used to grow or shrink the extent of an attribute in the text."

	| attrs markup oldTarget|
	self startIndex = self stopIndex ifTrue: [^ false].
	attrs := self text
		attributesOfKind: CtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1.
	
	attrs size > 1
		ifTrue: [^ self. "Can only modify one attribute here."].
	
	markup := attrs first markup.
	oldTarget := markup targets detect: [:target | target isMethodSource]. "There should only be one method-source-target yet."
	markup := markup copyWithTargetChangedFrom: oldTarget to: (CtMethodSourceTarget
		class: self theClass
		selector: self selector
		from: self startIndex
		to: self stopIndex - 1).
	
	self
		deferMarkupAdding: markup;
		removeAttribute: attrs first;
		addMarkup: markup.! !

!CtEditor methodsFor: 'private' stamp: 'mt 9/29/2010 09:57:06.461'!
restyle
	"Remove all CodeTalk text attributes from text and reset them."
	
	(morph text attributesOfKind: CtTextAttribute)
		do: [:attr | morph text removeAttribute: attr].
		
	CtSourceTextStyler new
		styleSource: morph text
		inClass: self theClass
		selector: self selector.

	(morph text attributesOfKind: CtReferenceAttribute)
		do: [:attr | attr addDependent: morph]. "to make the icons work"
		
	morph changed.! !

!CtEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sAddCodeChat: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self addCodeChat.
	^ true! !

!CtEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sAddComment: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self addComment.
	^ true! !

!CtEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sMarkAsBad: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self markAsBad.
	^ true! !

!CtEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 15:40'!
selector

	self model isDefinition ifTrue: [
		| def |
		def := self model getDefinition.
		(def isKindOf: OBMethodDefinition) ifTrue: [
			^ def selector]].
	^ nil! !

!CtEditor methodsFor: 'editing' stamp: 'mt 9/29/2010 11:29:28.545'!
tagSelectionWith: aSymbol
	"Tag the selected code or text with the symbol."

	| markup |
	self theClass ifNil: [^ self].
	
	self startIndex = self stopIndex ifTrue: [^ self].
	markup := CtMarkupGenerator new
		addTag: aSymbol;
		addTarget: (CtMethodSourceTarget
			class: self theClass
			selector: self selector
			from: self startIndex
			to: self stopIndex - 1);
		next.

	self
		deferMarkupAdding: markup;
		addMarkup: markup.! !

!CtEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 15:40'!
theClass

	self model isDefinition ifTrue: [
		| def |
		def := self model getDefinition.
		(def isKindOf: OBMethodDefinition) ifTrue: [
			^ def theClass]].
	^ nil! !

!CtEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 15:06'!
untagSelection

	(self text
		attributesOfKind: CtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1) do: [:attr |
			self removeMarkup: attr].! !

!CtEditor methodsFor: 'private' stamp: 'mt 9/28/2010 17:44:35.157'!
updateRanges
	"Create new markups if the range changed due to editing."
	
	(self text attributesOfKind: CtReferenceAttribute) do: [:ref |
		| interval target updatedMarkup |
		interval := self text find: ref.
		target := ref markup targets detect: [:t | t isMethodSource].
		updatedMarkup := ref markup
			copyWithTargetChangedFrom: target
			to: (CtMethodSourceTarget
				class: target theClass
				selector: target selector
				from: interval first
				to: interval last).
		deferredSystemMarkupsMessages nextPut: [SystemMarkups addMarkup: updatedMarkup]].! !

RemovedEvent subclass: #RemovedMarkupEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Events'!

!RemovedMarkupEvent class methodsFor: 'accessing' stamp: 'mt 9/22/2010 21:06:53.738'!
supportedKinds
	"All the kinds of items that this event can take."
	
	^ Array with: self markupKind! !

ImageMorph subclass: #CtAttributeIconMorph
	instanceVariableNames: 'attribute lastVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Icons'!

!CtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 6/11/2009 21:27'!
attribute

	^ attribute! !

!CtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 6/11/2009 21:27'!
attribute: anObject

	attribute := anObject.! !

!CtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:00:13'!
cleanUp
	"Perform some cleanup operations."! !

!CtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 7/2/2009 22:33'!
handlesMouseDown: evt

	^ true! !

!CtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:43'!
visible: aBoolean

	lastVisible = aBoolean ifTrue: [^ self].
	lastVisible := aBoolean.
	self disableTableLayout: aBoolean not.
	^ super visible: aBoolean! !

CtAttributeIconMorph subclass: #CtChatIconMorph
	instanceVariableNames: 'chat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Icons'!

!CtChatIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'View chat'! !

!CtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 14:49'!
chat

	chat ifNil: [chat := CtCodeChatMorph forAttribute: self attribute].
	^ chat! !

!CtChatIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:03:46'!
cleanUp

	super cleanUp.
	chat ifNotNilDo: [:chatMorph | chatMorph delete].! !

!CtChatIconMorph methodsFor: 'initialization' stamp: 'mt 6/2/2009 15:07'!
initialize

	super initialize.
	self image: (MenuIcons ctCommentsIcon).! !

!CtChatIconMorph methodsFor: 'event handling' stamp: 'mt 5/2/2010 14:48:49.445'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self chat
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld;
		extent: 260@200.! !

CtAttributeIconMorph subclass: #CtCommentIconMorph
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Icons'!

!CtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:45'!
balloonText

	^ 'View comment'! !

!CtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:05:17'!
cleanUp

	super cleanUp.
	editor ifNotNilDo: [:editorMorph | editorMorph delete].! !

!CtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 9/29/2010 09:56:00.269'!
editor

	editor ifNil: [editor := CtCodeChatMorph forAttribute: self attribute].
	^ editor! !

!CtCommentIconMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 20:12'!
initialize

	super initialize.
	self image: MenuIcons ctCommentIcon.! !

!CtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 5/2/2010 16:37:01.163'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self editor
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld;
		extent: 260@200.! !

CtAttributeIconMorph subclass: #CtDeleteIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Icons'!

!CtDeleteIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'Delete markup'! !

!CtDeleteIconMorph methodsFor: 'initialization' stamp: 'mt 5/1/2009 17:55'!
initialize

	super initialize.
	self image: (MenuIcons ctDeleteIcon).! !

!CtDeleteIconMorph methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:55'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestDeletion.! !

CtAttributeIconMorph subclass: #CtResizeIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Icons'!

!CtResizeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:17'!
balloonText

	^ 'Resize markup'! !

!CtResizeIconMorph methodsFor: 'initialization' stamp: 'mt 5/3/2009 19:18'!
initialize

	super initialize.
	self image: (MenuIcons ctPaintcanIcon).! !

!CtResizeIconMorph methodsFor: 'event handling' stamp: 'mt 5/3/2009 19:19'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestResizing.! !

!SystemChangeNotifier methodsFor: '*codetalk' stamp: 'mt 9/22/2010 21:18:50.381'!
markupAdded: aMarkup

	self trigger: (AddedMarkupEvent markup: aMarkup).! !

!SystemChangeNotifier methodsFor: '*codetalk' stamp: 'mt 9/23/2010 19:02:37.974'!
markupChangedFrom: oldMarkup to: newMarkup

	self trigger: (ModifiedMarkupEvent from: oldMarkup to: newMarkup).! !

!SystemChangeNotifier methodsFor: '*codetalk' stamp: 'mt 9/22/2010 21:19:26.888'!
markupRemoved: aMarkup

	self trigger: (RemovedMarkupEvent markup: aMarkup).! !

!OBCodeBrowser methodsFor: '*codetalk' stamp: 'mt 5/30/2009 15:07'!
cmdCodeTalk
	^ CtEditCommand allSubclasses! !

TestCase subclass: #CtCompiledMethodTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtCompiledMethodTests methodsFor: 'tests' stamp: 'mt 9/28/2010 14:55:49.921'!
test01sourceCodeHash

	| cm |
	cm := String class >> #cr.
	self
		assert: (SecureHashAlgorithm new hashMessage: cm getSource asString)
		equals: cm sourceCodeHash.! !

!CtCompiledMethodTests methodsFor: 'tests' stamp: 'mt 9/28/2010 14:56:30.467'!
test02sourceCodeHashViaClass

	| cm |
	cm := String class >> #cr.
	self
		assert: (SecureHashAlgorithm new hashMessage: cm getSource asString)
		equals: (String class sourceCodeHashAt: #cr).! !

TestCase subclass: #CtMarkupDatabaseTests
	instanceVariableNames: 'sut event markup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtMarkupDatabaseTests methodsFor: 'support' stamp: 'mt 9/23/2010 20:23:06.614'!
addMarkupWithTarget: aTarget

	| m |
	m := CtMarkup new.
	sut addMarkup: m.
	m := m copyWithTargetAdded: aTarget.
	sut addMarkup: m.

	! !

!CtMarkupDatabaseTests methodsFor: 'support' stamp: 'mt 9/23/2010 18:58:48.543'!
event: anEvent

	event := anEvent.! !

!CtMarkupDatabaseTests methodsFor: 'support' stamp: 'mt 9/23/2010 20:28:09.578'!
fillDatabase

	self
		addMarkupWithTarget: (CtClassTarget class: String);
		addMarkupWithTarget: (CtMethodTarget class: String selector: #displayAt:);
		addMarkupWithTarget: (CtPackageTarget package: String package);
		addMarkupWithTarget: CtProjectTarget new;
		addMarkupWithTarget: (CtProtocolTarget class: String protocol: #displaying);
		addMarkupWithTarget: (CtSystemCategoryTarget systemCategory: String category);
		addMarkupWithTarget: (CtClassCommentTarget class: String from: 5 to: 10);
		addMarkupWithTarget: (CtMethodSourceTarget class: String selector: #displayAt: from: 5 to: 10).! !

!CtMarkupDatabaseTests methodsFor: 'running' stamp: 'mt 9/23/2010 20:18:58.286'!
setUp

	super setUp.
	sut := CtMarkupDatabase new.
	markup := CtMarkup new.

	SystemChangeNotifier uniqueInstance notify: self ofSystemChangesOfItem: #markup using: #event:.! !

!CtMarkupDatabaseTests methodsFor: 'running' stamp: 'mt 9/23/2010 18:57:22.101'!
tearDown

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.
	super tearDown.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 18:51:37.737'!
test01addMarkups

	| markup |
	markup := CtMarkup new.
	
	self assert: sut isEmpty.
	sut addMarkup: markup.
	self deny: sut isEmpty.
	
	.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 18:51:58.029'!
test02removeMarkups

	| markup |
	markup := CtMarkup new.
	sut addMarkup: markup.
	sut removeMarkup: markup.
	
	self assert: sut isEmpty.
	
	.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:22:32.845'!
test03systemNotifications

	| markup markupCopy |
	markup := CtMarkup new.
	sut addMarkup: markup.
	
	self
		assert: event notNil;
		assert: event isAdded;
		assert: markup equals: event item.
		
	markupCopy := sut addMarkup: (markup copyWithTagAdded: #talk).
	
	self
		assert: event isModified;
		assert: markupCopy equals: event item;
		assert: markup equals: event oldItem.
		
	sut removeMarkup: markupCopy.
	
	self
		assert: event isRemoved;
		assert: markupCopy equals: event item.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 19:10:00.573'!
test04duplicateAdding

	| markup |
	markup := CtMarkup new.
	sut addMarkup: markup.
	event := nil.
	
	sut addMarkup: markup.
	
	self assert: event isNil.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 19:15:44.467'!
test05addInactiveMarkups

	| markup markupCopy |
	markup := CtMarkup new.
	markupCopy := markup copyWithTagAdded: #talk.
	
	sut addMarkup: markup.
	sut addMarkup: markupCopy.
	
	self
		should: [sut addMarkup: markup]
		raise: Error.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 20:32:06.692'!
test06queryAll
	
	self fillDatabase.
	
	self
		assert: 1 equals: (sut markupsOfKind: #class) size;
		assert: 1 equals: (sut markupsOfKind: #method) size;
		assert: 1 equals: (sut markupsOfKind: #package) size;
		assert: 1 equals: (sut markupsOfKind: #project) size;
		assert: 1 equals: (sut markupsOfKind: #protocol) size;
		assert: 1 equals: (sut markupsOfKind: #systemCategory) size;
		assert: 1 equals: (sut markupsOfKind: #classComment) size;
		assert: 1 equals: (sut markupsOfKind: #methodSource) size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 20:42:34.776'!
test07queryClasses
	
	self fillDatabase.
	
	self
		assert: 1 equals: (sut markupsForClass: String kind: #class) size;
		assert: 0 equals: (sut markupsForClass: String class kind: #class) size;
		assert: 1 equals: (sut markupsForClass: String kind: #method) size;
		assert: 0 equals: (sut markupsForClass: String class kind: #method) size;
		assert: 1 equals: (sut markupsForClass: String kind: #protocol) size;
		assert: 0 equals: (sut markupsForClass: String class kind: #protocol) size;
		assert: 0 equals: (sut markupsForClass: String kind: #package) size;
		assert: 0 equals: (sut markupsForClass: String kind: #project) size;
		assert: 0 equals: (sut markupsForClass: String kind: #systemCategory) size;
		assert: 1 equals: (sut markupsForClass: String kind: #classComment) size;
		assert: 0 equals: (sut markupsForClass: String class kind: #classComment) size;
		assert: 1 equals: (sut markupsForClass: String kind: #methodSource) size;
		assert: 0 equals: (sut markupsForClass: String class kind: #methodSource) size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 20:44:39.018'!
test08queryMethods
	
	self fillDatabase.
	
	self
		assert: 0 equals: (sut markupsForClass: String selector: #displayAt: kind: #class) size;
		assert: 1 equals: (sut markupsForClass: String selector: #displayAt: kind: #method) size;
		assert: 0 equals: (sut markupsForClass: String selector: #displayAt: kind: #protocol) size;
		assert: 0 equals: (sut markupsForClass: String selector: #displayAt: kind: #package) size;
		assert: 0 equals: (sut markupsForClass: String selector: #displayAt: kind: #project) size;
		assert: 0 equals: (sut markupsForClass: String selector: #displayAt: kind: #systemCategory) size;
		assert: 0 equals: (sut markupsForClass: String selector: #displayAt: kind: #classComment) size;
		assert: 1 equals: (sut markupsForClass: String selector: #displayAt: kind: #methodSource) size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 20:46:32.403'!
test09queryProtocols
	
	self fillDatabase.
	
	self
		assert: 0 equals: (sut markupsForClass: String protocol: #displaying kind: #class) size;
		assert: 1 equals: (sut markupsForClass: String protocol: #displaying kind: #method) size;
		assert: 1 equals: (sut markupsForClass: String protocol: #displaying kind: #protocol) size;
		assert: 0 equals: (sut markupsForClass: String protocol: #displaying kind: #package) size;
		assert: 0 equals: (sut markupsForClass: String protocol: #displaying kind: #project) size;
		assert: 0 equals: (sut markupsForClass: String protocol: #displaying kind: #systemCategory) size;
		assert: 0 equals: (sut markupsForClass: String protocol: #displaying kind: #classComment) size;
		assert: 1 equals: (sut markupsForClass: String protocol: #displaying kind: #methodSource) size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 20:48:18.962'!
test10queryPackages
	
	self fillDatabase.
	
	self
		assert: 1 equals: (sut markupsForPackage: String package kind: #class) size;
		assert: 1 equals: (sut markupsForPackage: String package kind: #method) size;
		assert: 1 equals: (sut markupsForPackage: String package kind: #protocol) size;
		assert: 1 equals: (sut markupsForPackage: String package kind: #package) size;
		assert: 0 equals: (sut markupsForPackage: String package kind: #project) size;
		assert: 1 equals: (sut markupsForPackage: String package kind: #systemCategory) size;
		assert: 1 equals: (sut markupsForPackage: String package kind: #classComment) size;
		assert: 1 equals: (sut markupsForPackage: String package kind: #methodSource) size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/23/2010 20:49:17.875'!
test11querySystemCategories
	
	self fillDatabase.
	
	self
		assert: 1 equals: (sut markupsForSystemCategory: String category kind: #class) size;
		assert: 1 equals: (sut markupsForSystemCategory: String category kind: #method) size;
		assert: 1 equals: (sut markupsForSystemCategory: String category kind: #protocol) size;
		assert: 0 equals: (sut markupsForSystemCategory: String category kind: #package) size;
		assert: 0 equals: (sut markupsForSystemCategory: String category kind: #project) size;
		assert: 1 equals: (sut markupsForSystemCategory: String category kind: #systemCategory) size;
		assert: 1 equals: (sut markupsForSystemCategory: String category kind: #classComment) size;
		assert: 1 equals: (sut markupsForSystemCategory: String category kind: #methodSource) size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/24/2010 10:00:26.475'!
test12anchestryForMarkup

	| m1 m2 m3 anchestry |
	m1 := CtMarkup new.
	m2 := m1 copyWithTagAdded: #talk.
	m3 := m2 copyWithTagAdded: #bad.
	
	sut addMarkup: m1.
	sut addMarkup: m2.
	sut addMarkup: m3.
	
	anchestry := sut anchestryForMarkup: m3.
	
	self
		assert: 2 equals: anchestry size;
		assert: m2 equals: anchestry first;
		assert: m1 equals: anchestry second.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:16:55.795'!
test13createSnapshot

	| snapshot |
	self fillDatabase.
	snapshot := sut createSnapshot: String package name.
	
	self
		assert: 7 equals: snapshot activeMarkups size;
		assert: 7 equals: snapshot inactiveMarkups size.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:20:18.942'!
test14loadSnapshot

	| snapshot db |
	self fillDatabase.
	snapshot := sut createSnapshot: String package name.

	"Create second database, merge the current state, make some changes and create a snapshot again."
	db := CtMarkupDatabase new.
	db loadSnapshot: snapshot.
	db removeMarkup: (db markupsForClass: String kind: #class) first.
	db addMarkup: ((db markupsForClass: String kind: #protocol) first copyWithTagAdded: #comment).
	snapshot := db createSnapshot: String package name.
	
	"Make some changes in the first database."
	sut removeMarkup: (sut markupsForClass: String kind: #method) first.
	sut addMarkup: ((sut markupsForClass: String kind: #protocol) first copyWithTagAdded: #talk).
	sut loadSnapshot: snapshot.
	
	self
		assert: (sut markupsForClass: String kind: #class) isEmpty;
		assert: 1 equals: (sut markupsForClass: String kind: #method) size;
		assert: (sut markupsForClass: String kind: #protocol) first tags first = #comment.
		
	snapshot := sut createSnapshot: String package name.
	
	"That markup was deleted but re-added with loading the snapshot. It must not be in the inactive list too."
	self deny: ((sut instVarNamed: #inactiveMarkups) includesKey: (sut markupsForClass: String kind: #method) first uuid).! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/27/2010 14:01:16.179'!
test15addGeneratedMarkup

	| markup |
	markup := CtMarkupGenerator new
		addTag: #foobar;
		addTarget: CtProjectTarget new;
		addTalkMessage: (CtTalkMessage text: 'Hello, World.');
		next.
		
	sut addMarkup: markup.
	self assert: markup equals: (sut markupsOfKind: #project) first.! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/28/2010 12:10:59.552'!
test16tagCollection

	| markup oldTags |
	markup := CtMarkupGenerator new
		addTag: #foobar;
		next.
	
	oldTags := sut tags.
	sut addMarkup: markup.

	self
		assert: oldTags size + 1 equals: sut tags size;
		assert: (sut tags includes: #foobar).! !

!CtMarkupDatabaseTests methodsFor: 'tests' stamp: 'mt 9/28/2010 12:42:14.558'!
test17addGeneratedMarkupAgain

	| markup |
	markup := CtMarkupGenerator new
		addTag: #foobar;
		addTarget: (CtMethodSourceTarget class: String class selector: #cr from: 5 to: 10);
		addTalkMessage: (CtTalkMessage text: 'Hello, World.');
		next.
		
	sut addMarkup: markup.
	self assert: markup equals: (sut markupsOfKind: #methodSource) first.! !

TestCase subclass: #CtMarkupGeneratorTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtMarkupGeneratorTests methodsFor: 'running' stamp: 'mt 9/27/2010 13:50:37.437'!
setUp

	super setUp.
	sut := CtMarkupGenerator new.! !

!CtMarkupGeneratorTests methodsFor: 'tests' stamp: 'mt 9/27/2010 13:52:00.924'!
test01initialMarkup

	| markup |
	markup := sut next.
	
	self
		assert: markup talk isEmpty;
		assert: markup tags = CtMarkup new tags;
		assert: markup targets isEmpty.! !

!CtMarkupGeneratorTests methodsFor: 'tests' stamp: 'mt 9/27/2010 13:54:39.85'!
test02generate

	| markup |
	sut
		addTag: #foobar;
		addTarget: CtProjectTarget new;
		addTalkMessage: (CtTalkMessage text: 'Hello, World.').
	markup := sut next.
	
	self
		assert: 1 equals: markup talk size;
		assert: (markup tags includes: #foobar);
		assert: 1 equals: markup targets size.! !

!CtMarkupGeneratorTests methodsFor: 'tests' stamp: 'mt 9/27/2010 13:55:44.015'!
test03generateAgain

	| markup |
	sut
		addTag: #foobar;
		addTarget: CtProjectTarget new;
		addTalkMessage: (CtTalkMessage text: 'Hello, World.').
	markup := sut next; next.
	
	self
		assert: markup talk isEmpty;
		assert: markup tags = CtMarkup new tags;
		assert: markup targets isEmpty.! !

TestCase subclass: #CtMarkupTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/23/2010 14:38:28.551'!
test01markupImmutable

	| markup author |
	markup := CtMarkup new.
	author := markup author.
	markup author at: 1 put: $#.
	
	self assert: author equals: markup author.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:32:56.716'!
test02addTalkMessage

	| markup markupCopy |
	markup := CtMarkup new.
	markupCopy := markup copyWithTalkMessageAdded: (CtTalkMessage text: 'Hello!!').
	
	self
		assert: markup ~~ markupCopy;
		assert: markup talk isEmpty;
		assert: 1 equals: markupCopy talk size.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/28/2010 15:59:11.204'!
test03anchestry

	| m1 m2 m3 |
	m1 := CtMarkup new.
	m2 := m1 copyWithTalkMessageAdded: (CtTalkMessage text: 'Hello!!').
	m3 := m2 copyWithTalkMessageAdded: (CtTalkMessage text: 'What''s up?').
	
	self
		assert: m1 anchestor isNil;
		assert: m1 uuid equals: m2 anchestor;
		assert: m2 uuid equals: m3 anchestor;
		assert: m1 uuid ~= m2 uuid;
		assert: m1 uuid ~= m3 uuid;
		assert: m2 uuid ~= m3 uuid;
		assert: m1 timestamp equals: m2 timestamp;
		assert: m1 timestamp equals: m3 timestamp.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/23/2010 15:28:41.653'!
test04addTag

	| markup markupCopy |
	markup := CtMarkup new.
	markupCopy := markup copyWithTagAdded: #talk.
	
	self
		assert: markup ~~ markupCopy;
		assert: markup tags isEmpty;
		assert: #talk equals: markupCopy tags first.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/23/2010 15:29:25.781'!
test05removeTag

	| markup markupCopy |
	markup := CtMarkup new copyWithTagAdded: #talk.
	markupCopy := markup copyWithTagRemoved: #talk.
	
	self
		assert: markup ~~ markupCopy;
		assert: markupCopy tags isEmpty.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:46:11.816'!
test06addTarget

	| markup markupCopy |
	markup := CtMarkup new.
	markupCopy := markup copyWithTargetAdded: (CtClassTarget class: String).
	
	self
		assert: markup ~~ markupCopy;
		assert: markup targets isEmpty;
		assert: String equals: markupCopy targets first theClass.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:47:16.411'!
test07removeTarget

	| markup markupCopy |
	markup := CtMarkup new copyWithTargetAdded: (CtClassTarget class: String).
	markupCopy := markup copyWithTargetRemoved: markup targets first.
	
	self
		assert: markup ~~ markupCopy;
		assert: markupCopy targets isEmpty.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/24/2010 09:47:46.622'!
test08changeTarget

	| markup markupCopy |
	markup := CtMarkup new copyWithTargetAdded: (CtClassTarget class: String).
	markupCopy := markup copyWithTargetChangedFrom: markup targets first to: (CtClassTarget class: Integer).
	
	self
		assert: markup ~~ markupCopy;
		assert: Integer equals: markupCopy targets first theClass.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:31:13.225'!
test09talkImmutable

	| markup talk |
	markup := CtMarkup new.
	talk := markup talk.
	
	self assert: talk isEmpty.
	talk := talk copyWith: (CtTalkMessage text: 'Hello!!').
	self
		assert: talk notEmpty;
		assert: markup talk isEmpty.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:32:17.56'!
test10talkMessageImmutable

	| msg author text |
	msg := CtTalkMessage text: 'Hello!!' asText.
	author := msg author.
	text := msg text.
	
	msg author at: 1 put: $#.
	msg text append: 'Hello again!!'.
	
	self
		assert: author equals: msg author;
		assert: text equals: msg text.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/27/2010 11:32:39.211'!
test11copyTalkMessage

	| msg msgCopy |
	msg := CtTalkMessage text: 'Hello!!'.
	msgCopy := msg copy.
	
	self
		assert: msg ~~ msgCopy;
		assert: msg author = msgCopy author;
		assert: msg timestamp == msgCopy timestamp;
		assert: msg text = msgCopy text.! !

!CtMarkupTests methodsFor: 'tests' stamp: 'mt 9/27/2010 13:03:35.101'!
test12changeTag

	| markup markupCopy |
	markup := CtMarkup new copyWithTagAdded: #talk.
	markupCopy := markup copyWithTagChangedFrom: #talk to: #bad.
	
	self
		assert: #(talk) equals: markup tags;
		assert: #(bad) equals: markupCopy tags.! !

TestCase subclass: #CtTargetTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:16:42.348'!
test01methodTarget

	| target |
	target := CtMethodTarget class: String selector: #displayAt:.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String equals: target theClass;
		assert: (String>>#displayAt:) equals: target method;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory;
		assert: #displaying equals: target protocol.
	
	"Test static contents."
	self
		assert: #displayAt: equals: target selector;
		assert: (SecureHashAlgorithm new hashMessage: (String sourceCodeAt: #displayAt:) asString) equals: target sourceHash.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:20:33.387'!
test02classTarget

	| target |
	target := CtClassTarget class: String.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String equals: target theClass;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 16:47:42.863'!
test03protocolTarget

	| target |
	target := CtProtocolTarget class: String protocol: #displaying.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String equals: target theClass;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory.
		
	"Test static contents."
	self assert: #displaying equals: target protocol.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 16:52:52.958'!
test04systemCategoryTarget

	| target |
	target := CtSystemCategoryTarget systemCategory: String category.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String package equals: target package.
		
	"Test static contents."
	self assert: String category equals: target systemCategory.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:18:05.467'!
test05packageTarget

	| target |
	target := CtPackageTarget package: String package.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String package equals: target package.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:26:17.924'!
test06rangeTarget

	| target |
	target := CtRangeTarget from: 5 to: 10.
	
	self
		assert: 5 equals: target startIndex;
		assert: 10 equals: target stopIndex.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:35:59.722'!
test07classCommentTarget

	| target |
	target := CtClassCommentTarget class: String from: 5 to: 10.
	
	self
		assert: target isAvailable;
		assert: String equals: target theClass;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory;
		assert: String comment equals: target item.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 17:40:31.363'!
test08methodSourceTarget

	| target |
	target := CtMethodSourceTarget class: String selector: #displayAt: from: 5 to: 10.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String equals: target theClass;
		assert: (String>>#displayAt:) equals: target method;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory;
		assert: #displaying equals: target protocol.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 19:42:03.786'!
test09classTargetWithMetaClass

	| target |
	target := CtClassTarget class: String class.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String class equals: target theClass;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory.! !

!CtTargetTests methodsFor: 'tests' stamp: 'mt 9/23/2010 19:48:07.296'!
test10methodTargetWithMetaClass

	| target |
	target := CtMethodTarget class: String class selector: #cr.
	
	"Test dynamic contents."
	self
		assert: target isAvailable;
		assert: String class equals: target theClass;
		assert: (String class >> #cr) equals: target method;
		assert: String package equals: target package;
		assert: String category equals: target systemCategory;
		assert: #'instance creation' equals: target protocol.
	
	"Test static contents."
	self
		assert: #cr equals: target selector;
		assert: (SecureHashAlgorithm new hashMessage: (String class sourceCodeAt: #cr) asString) equals: target sourceHash.! !

!OBTextSelection methodsFor: '*codetalk' stamp: 'mt 5/3/2009 18:39'!
start

	^ selection first! !

!OBTextSelection methodsFor: '*codetalk' stamp: 'mt 5/3/2009 18:39'!
stop

	^ selection last! !

BorderedMorph subclass: #CtAttributeEditorMorph
	instanceVariableNames: 'model closeButton title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Editor'!

!CtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:37'!
defaultExtent

	^ 200@150! !

!CtAttributeEditorMorph class methodsFor: 'instance creation' stamp: 'mt 5/28/2009 19:37'!
forAttribute: anXpfAttribute

	^ self new
		attribute: anXpfAttribute! !

!CtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ self subclassResponsibility! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 9/28/2010 15:23:48.59'!
attribute: aMarkupReferenceAttribute

	self model ifNil: [^ self].
	self model attribute: aMarkupReferenceAttribute.
	self title contents: ('{1} - {2}' format: {
			aMarkupReferenceAttribute timestamp printRelativeTimeStamp.
			aMarkupReferenceAttribute creator}).
	self color: (aMarkupReferenceAttribute color lighter lighter alpha: 0.8).! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:28'!
closeButton

	closeButton ifNil: [closeButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons ctCrossIcon;
			actionSelector: #delete;
			useRoundedCorners;
			setBalloonText: 'Close window'].
	^ closeButton! !

!CtAttributeEditorMorph methodsFor: 'drawing' stamp: 'mt 5/2/2010 14:41:16.555'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	aCanvas
		frameRectangle: (self bounds insetBy: (1@1))
		color: (self color muchDarker).
	
	aCanvas
		line: self topLeft + (1 @ 1)
		to: self topRight + (-1 @ 1)
		color: (self color muchLighter).

	aCanvas
		line: self topLeft + (1 @ 1)
		to: self bottomLeft + (1 @ -2)
		color: (self color muchLighter).
	
	aCanvas
		frameRectangle: self bounds
		color: (self color muchDarker muchDarker)..
! !

!CtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/2/2010 14:40:39.067'!
initialize

	super initialize.
	self
		hResizing: #rigid;
		vResizing: #rigid;
		listDirection: #topToBottom;
		borderWidth: 0;
		changeTableLayout;
		layoutInset: 5;
		cellInset: 5;
		extent: 250@200;
		initializeUserInterface.! !

!CtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:29'!
initializeUserInterface

	^ self subclassResponsibility! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:40'!
model

	model ifNil: [model := self class modelClass new].
	^ model! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 9/27/2010 11:47:20.074'!
title

	title ifNil: [title := 'Editor' asText asMorph.
		title hResizing: #spaceFill.
		title setBalloonText: 'Creation time and creator'].
	^ title! !

CtAttributeEditorMorph subclass: #CtCodeChatMorph
	instanceVariableNames: 'chatLog textEntry addMessageButton searchEntry searchButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Editor'!

!CtCodeChatMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ CtCodeChatModel! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 17:56'!
addMessageButton

	addMessageButton ifNil: [addMessageButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self textEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons ctCommentAddIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Add message'].
	^ addMessageButton! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 9/27/2010 11:49:19.433'!
chatLog

	chatLog ifNil: [chatLog := (PluggableTextMorph
		on: self model
		text: #messages
		accept: nil)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellInset: 0;
		layoutInset: 0;
		borderWidth: 0;
		fillStyle: Color white].
	^ chatLog! !

!CtCodeChatMorph methodsFor: 'initialization' stamp: 'mt 4/14/2010 16:50:01.479'!
initializeUserInterface

	self
		addMorphBack: (SwaRowPanel for: {
			self title.
			self closeButton});
		"addMorphBack: (self newRowFor: {
			self searchEntry.
			self searchButton});"
		addMorphBack: self chatLog;
		addMorphBack: (SwaRowPanel for: {
			self textEntry.
			self addMessageButton}).! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:18'!
searchButton

	searchButton ifNil: [searchButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self searchEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons ctMagnifierIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Highlight messages with keyword.'].
	^ searchButton! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:19'!
searchEntry

	searchEntry ifNil: [searchEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: nil
		set: #searchString:
		class: String
		getEnabled: nil
		help: 'Type a keyword to hightlight messages which contain that keyword.'.
		searchEntry
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Look for keyword...'].
	^ searchEntry! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2010 11:34:58.179'!
textEntry

	textEntry ifNil: [textEntry := SwaLineEdit
		for: self model
		get: #newMessage
		set: #addMessage:.
		textEntry
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Type message here...';
			acceptOnCR: true].
	^ textEntry! !

BorderedMorph subclass: #CtRowMorph
	instanceVariableNames: 'lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Icons'!

!CtRowMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:18'!
for: someMorphs

	| instance |
	instance := self new.
	someMorphs do: [:m | instance addMorphBack: m].
	^ instance! !

!CtRowMorph methodsFor: 'accessing' stamp: 'mt 3/3/2010 16:07:05'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 3;
		useRoundedCorners;
		cellInset: 3;
		borderWidth: 0;
		color: (Color r: 4 g: 133 b: 157 alpha: 0.9).! !

!CtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 14:12'!
position: aPoint

	aPoint = lastPosition ifTrue: [^ self].
	lastPosition := aPoint.
	super position: aPoint.! !

SHTextStylerST80 subclass: #CtTextStyler
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text'!

!CtTextStyler methodsFor: 'private' stamp: 'mt 1/17/2010 13:30'!
setAttributesIn: aText fromRanges: ranges
	"CodeTalk: Reimplemented due to strange interpretation of #shoutShouldPreserve."

	| charAttr defaultAttr attr newRuns newValues lastAttr oldRuns lastCount | 		
		
	oldRuns := aText runs.
	defaultAttr := self attributesFor: #default.
	charAttr := Array new: aText size.
	1 to: charAttr size do: [:i | charAttr at: i put: defaultAttr].
	ranges do: [:range |
		(attr := self attributesFor: range type) == nil
			ifFalse:[	range start to: range end do: [:i | charAttr at: i put: attr]]].
	newRuns := OrderedCollection new: charAttr size // 10.
	newValues := OrderedCollection new: charAttr size // 10.
	1 to: charAttr size do: [:i |
		attr := charAttr at: i.
		i = 1 
			ifTrue: [
				newRuns add: 1.
				lastCount := 1.
				lastAttr := newValues add: attr]
			ifFalse:[
				attr == lastAttr
					ifTrue: [
						lastCount := lastCount + 1.
						newRuns at: newRuns size put: lastCount]
					ifFalse: [
						newRuns add: 1.
						lastCount := 1.
						lastAttr := newValues add: attr]]].	
	aText runs: (RunArray runs: newRuns values: newValues).
	oldRuns withStartStopAndValueDo:[:start :stop :attribs|
		attribs do: [:eachAttrib | eachAttrib shoutShouldPreserve
			ifTrue: [aText addAttribute: eachAttrib from: start to: stop]]].
	! !

!CtTextStyler methodsFor: 'converting' stamp: 'mig 6/7/2010 00:02:22.454'!
unstyledTextFrom: aText
	"Avoid to write custom attributes into the changes file."

	(text attributesOfKind: CtMorphAttribute) do: [:attr | attr cleanUp].
		
	^ super unstyledTextFrom: aText.
! !

OBCodeNode subclass: #CtSeparatorNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Nodes'!

!CtSeparatorNode class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 14:15'!
text: aString

	^ self new
		text: aString! !

!CtSeparatorNode methodsFor: 'testing' stamp: 'mt 5/25/2009 14:47'!
isSeparatorNode

	^ true! !

!CtSeparatorNode methodsFor: 'public' stamp: 'mt 5/25/2009 14:48'!
name

	^ text asText allBold! !

!CtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:15'!
text

	^ text! !

!CtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:14'!
text: anObject

	text := anObject.! !

!CompiledMethod methodsFor: '*codetalk' stamp: 'mt 9/28/2010 14:51:24.199'!
sourceCodeHash

	^ SecureHashAlgorithm new hashMessage: (self getUnstyledSourceFor: self selector in: self methodClass) asString! !

!AbstractEvent class methodsFor: '*codetalk-override' stamp: 'mt 9/22/2010 21:12:21.257'!
allItemKinds
	"self allItemKinds"

	^ ((AbstractEvent class organization listAtCategoryNamed: #'item kinds')
		collect: [:sel | self perform: sel]), {self markupKind}! !

!AbstractEvent class methodsFor: '*codetalk' stamp: 'mt 9/22/2010 21:16:34.554'!
markup: aMarkup

	| instance |
	instance := self item: aMarkup kind: self markupKind.
	^instance! !

!AbstractEvent class methodsFor: '*codetalk' stamp: 'mt 9/22/2010 20:43:10.629'!
markupKind

	^ #markup! !

!AbstractEvent methodsFor: '*codetalk' stamp: 'mt 9/22/2010 20:45:30.119'!
itemMarkup

	^ self environmentAt: self class markupKind! !

!AbstractEvent methodsFor: '*codetalk' stamp: 'mt 9/22/2010 20:46:14.013'!
itemMarkup: aMarkup

	environment at: self class markupKind put: aMarkup! !

!Behavior methodsFor: '*codetalk' stamp: 'mt 9/28/2010 14:52:16.909'!
sourceCodeHashAt: selector

	^ (self methodDict at: selector) sourceCodeHash! !

TextAttribute subclass: #CtTextAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Attributes'!

!CtTextAttribute commentStamp: 'mt 1/16/2010 16:47' prior: 0!
I am a text attribute that is capable of displaying itself in some bounds.!

CtTextAttribute subclass: #CtMorphAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Attributes'!

!CtMorphAttribute commentStamp: 'mt 1/16/2010 16:59' prior: 0!
I am a CodeTalk text attribute that contains a morph which will be displayed inline.!

CtMorphAttribute subclass: #CtIconBarAttribute
	instanceVariableNames: 'chatMorph deleteMorph resizeMorph morph mode reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Attributes'!

!CtIconBarAttribute class methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 19:08'!
forReference: aReferenceAttribute

	^ self new
		reference: aReferenceAttribute! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:14'!
chatMorph

	^ chatMorph ifNil: [chatMorph := CtChatIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:09'!
deleteMorph

	^ deleteMorph ifNil: [deleteMorph := CtDeleteIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 9/29/2010 10:12:06.832'!
iconMorphs

	^ {self chatMorph. self deleteMorph. self resizeMorph}! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 18:00'!
mode

	^ mode! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:05'!
mode: anObject

	mode := anObject.
	morph := nil.! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 9/29/2010 10:11:55.286'!
morph

	morph ifNil: [morph := CtRowMorph for: {
		self chatMorph.
		self resizeMorph.
		self deleteMorph}].
	^ morph! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:07'!
reference

	^ reference! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 9/27/2010 11:54:27.123'!
reference: aReferenceAttribute

	reference := aReferenceAttribute.
	
	aReferenceAttribute addFriend: self.
	self mode: aReferenceAttribute markup tags first.! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:09'!
resizeMorph

	^ resizeMorph ifNil: [resizeMorph := CtResizeIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'displaying' stamp: 'mt 3/19/2010 11:27:09.027'!
updateMorphs: someAttributes start: startIndex stop: stopIndex

	((someAttributes size = 1) and: [startIndex ~= stopIndex])
		ifTrue: [self resizeMorph visible: true]
		ifFalse: [self resizeMorph visible: false].
	self morph layoutChanged.! !

!CtMorphAttribute methodsFor: 'cleanup' stamp: 'mt 1/22/2010 11:17:34'!
cleanUp

	self iconMorphs do: [:m | m cleanUp]! !

!CtMorphAttribute methodsFor: 'accessing' stamp: 'mt 1/22/2010 11:06:13'!
iconMorphs
	"Return all CtAttributeIcon instances."
	
	^ #()! !

!CtMorphAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:57'!
morph

	^ self subclassResponsibility.! !

!CtMorphAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:12'!
updateMorphs: someMorphAttributes start: startIndex stop: stopIndex
	"Use the chance to change your own appearance (e.g., visibility) according to the current selection."! !

CtTextAttribute subclass: #CtReferenceAttribute
	instanceVariableNames: 'markup friends theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Attributes'!

!CtReferenceAttribute commentStamp: 'mt 1/16/2010 19:10' prior: 0!
I am a reference for a markup to be used in a text.!

!CtReferenceAttribute class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 19:12'!
forMarkup: aMarkup

	^ self new
		markup: aMarkup! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 9/28/2010 17:05:07.61'!
addChatLine: aMessage

	| changedMarkup |
	changedMarkup := self markup copyWithTalkMessageAdded: (CtTalkMessage text: aMessage).
	self
		changed: #markupAdded with: changedMarkup;
		markup: changedMarkup.
	! !

!CtReferenceAttribute methodsFor: 'friends' stamp: 'mt 1/17/2010 14:28'!
addFriend: aTextAttribute

	self friends add: aTextAttribute.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 9/27/2010 11:56:16.829'!
chat

	^ self markup talk! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:03'!
color

	^ self markup color! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:43'!
compiledMethod

	self theClass ifNil: [^ nil].
	self selector ifNil: [^ nil].
	^ self theClass >> self selector! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 9/27/2010 11:57:22.669'!
creator

	^ self markup author! !

!CtReferenceAttribute methodsFor: 'friends' stamp: 'mt 1/17/2010 14:27'!
friends
	"Friends are other text attributes that belong to this reference attribute and so should have the same range as defined in the markup."

	^ friends ifNil: [friends := OrderedCollection new]! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:11'!
markup

	^ markup! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:11'!
markup: anObject

	markup := anObject.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 9/29/2010 16:06:23.886'!
read
	"Read this markup. You need CT-Monticello package for this."
	
	(Smalltalk at: #CtReadCache ifAbsent: [])
		ifNotNil: [:c | c read: self markup].! !

!CtReferenceAttribute methodsFor: 'signals' stamp: 'mt 1/16/2010 19:16'!
requestDeletion

	self changed: #deleteRequested with: self.! !

!CtReferenceAttribute methodsFor: 'signals' stamp: 'mt 1/16/2010 19:16'!
requestResizing
	"No need to give us away because the pure selection in a paragraph will handle this."

	self changed: #resizeRequested.! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:34'!
selector

	^ selector! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:34'!
selector: anObject

	selector := anObject.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 9/27/2010 12:59:10.758'!
tag

	^ self markup tags first! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 9/28/2010 17:05:25.419'!
tag: aSymbol

	| changedMarkup |
	changedMarkup := self markup copyWithTagChangedFrom: self tag to: aSymbol.
	self
		changed: #markupAdded with: changedMarkup;
		markup: changedMarkup.! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:33'!
theClass

	^ theClass! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:33'!
theClass: anObject

	theClass := anObject.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:02'!
timestamp

	^ self markup timestamp! !

!CtTextAttribute methodsFor: 'testing' stamp: 'mt 1/16/2010 16:49'!
= other

	^ self == other! !

!CtTextAttribute methodsFor: 'dependents access' stamp: 'mt 1/16/2010 19:06'!
addDependent: anObject

	(self dependents includes: anObject)
		ifTrue: [^ self].
		
	^ super addDependent: anObject.! !

!CtTextAttribute methodsFor: 'html' stamp: 'mt 1/16/2010 16:48'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!CtTextAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 16:50'!
displayOn: aCanvas in: drawBounds
	"Invisible."! !

!CtTextAttribute methodsFor: 'html' stamp: 'mt 1/16/2010 16:48'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span>'! !

!CtTextAttribute methodsFor: 'styling' stamp: 'mig 6/6/2010 23:55:48.223'!
shoutShouldPreserve
	
	^ true! !

CtTextAttribute subclass: #CtTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text-Attributes'!

!CtTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 17:17'!
color: aColor

	^ self new
		color: aColor! !

!CtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:18'!
green

	^ self color: (Color green alpha: 0.4)! !

!CtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:18'!
red

	^ self color: (Color red alpha: 0.4)! !

!CtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:19'!
yellow

	^ self color: (Color yellow alpha: 0.4)! !

!CtTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/16/2010 17:19'!
color

	^ color ifNil: [color := Color transparent]! !

!CtTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/16/2010 17:16'!
color: anObject

	color := anObject.! !

!CtTextBackgroundColor methodsFor: 'displaying' stamp: 'mt 9/27/2010 11:24:50.269'!
displayOn: aCanvas in: drawBounds
	"Draw a colored rectangle as background for text."
	
	aCanvas
		fillRectangle: drawBounds
		color: self color.! !

OBTextMorphWithShout subclass: #CtTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text'!

!CtTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2010 10:04:08.38'!
addMorph: aMorph
	"Optimized version of morph-adding. Needed because it is called frequently from CtParagraph."
	
	(self submorphs includes: aMorph)
		ifFalse: [^ super addMorph: aMorph].
	^ aMorph! !

!CtTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^CtEditor! !

!CtTextMorph methodsFor: 'testing' stamp: 'mt 1/17/2010 16:54'!
hasUnacceptedEdits

	^ self editView hasUnacceptedEdits! !

!CtTextMorph methodsFor: 'initialization' stamp: 'mt 9/29/2010 15:07:59.132'!
initialize

	super initialize.
	
	CtPreferences showLineNumbers ifTrue: [
		self margins: 
			(((Preferences standardCodeFont widthOfString: '99') * 1.7) rounded@0 corner: 0@0)].! !

!CtTextMorph methodsFor: 'private' stamp: 'mt 4/22/2009 20:24'!
paragraphClass
	
	^ CtParagraph! !

!CtTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2010 10:01:08.969'!
removeAllMorphsBut: someMorphs

	self submorphs copy do: [:m | (someMorphs includes: m)
		ifFalse: [m delete]]! !

!CtTextMorph methodsFor: 'updating' stamp: 'mt 9/29/2010 09:59:52.905'!
update: aSymbol

	super update: aSymbol.

	aSymbol = #resizeRequested
		ifTrue: [self editor resizeMarkup].! !

!CtTextMorph methodsFor: 'updating' stamp: 'mt 9/28/2010 17:04:35.923'!
update: aSymbol with: anObject

	aSymbol = #deleteRequested
		ifTrue: [self editor removeMarkup: anObject].
	aSymbol = #markupAdded
		ifTrue: [self editor deferMarkupAdding: anObject].
	
	super update: aSymbol with: anObject.! !

!OBDefinitionPanel methodsFor: '*codetalk-override' stamp: 'mt 9/22/2010 15:20:42.154'!
buildOn: aBuilder
	"See OBMorphBuilder>>#textArea:."
	
	^aBuilder textarea: self! !

!OBDefinitionPanel methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:21:46.039'!
contentMorph

	^ contentMorph! !

!OBDefinitionPanel methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:22:02.84'!
contentMorph: aMorph

	contentMorph := aMorph.! !

!OBNode methodsFor: '*codetalk' stamp: 'mt 5/25/2009 14:46'!
isSeparatorNode

   ^false! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self category! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 9/28/2010 16:24:43.648'!
methodSourceMarkups

	^ SystemMarkups
		markupsForClass: self theClass
		selector: self selector
		kind: #methodSource! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 5/3/2009 09:55'!
sourceText

	^ self source! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 1/17/2010 11:40'!
timeStamp

	^ (self theClass >> self selector) timeStamp! !

!OBPluggableTextMorphWithShout class methodsFor: '*codetalk-override' stamp: 'mt 5/1/2009 15:45'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	"CodeTalk: Use the XpfStyler right now."
	
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^CtTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*codetalk-override' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^CtTextMorph! !

!OBPluggableTextMorphWithShout methodsFor: '*codetalk' stamp: 'mt 1/22/2010 13:11:15'!
update: aSymbol

	aSymbol = getTextSelector ifTrue: [
		textMorph ifNotNilDo: [:tm | (tm contents attributesOfKind: CtMorphAttribute)
			do: [:attr | attr cleanUp]]].

	super update: aSymbol.! !

OBCommand subclass: #CtEditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

CtEditCommand subclass: #CtCmdAddComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

!CtCmdAddComment methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute

	self textMorph editor addComment.! !

!CtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '2'! !

!CtCmdAddComment methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:21:41'!
icon

	^ #ctMarkGreenIcon! !

!CtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:50'!
label

	^ 'add comment'! !

CtEditCommand subclass: #CtCmdChangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

!CtCmdChangeTag methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor changeMarkupTag.! !

!CtCmdChangeTag methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!CtCmdChangeTag methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target fullText
		includesAttributesOfKind: CtReferenceAttribute
		from: target start
		to: (target stop max: target start)! !

!CtCmdChangeTag methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:55'!
label

	^ 'change tag'! !

CtEditCommand subclass: #CtCmdJustTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

!CtCmdJustTalk methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor addCodeChat.! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:20'!
group

	^ '1'! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:21:55'!
icon

	^ #ctMarkYellowIcon! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $t! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:47'!
label

	^ 'add code chat'! !

CtEditCommand subclass: #CtCmdMarkBad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

!CtCmdMarkBad methodsFor: 'editor-bridge' stamp: 'mt 6/11/2009 17:43'!
execute

	self textMorph editor markAsBad.! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:00'!
group

	^ '1'! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:20:39'!
icon

	^ #ctMarkRedIcon! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $r! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

CtEditCommand subclass: #CtCmdRemoveMarkup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

!CtCmdRemoveMarkup methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute
	
	self textMorph editor removeMarkup.! !

!CtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!CtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:23'!
icon

	^ #ctDeleteIcon! !

!CtCmdRemoveMarkup methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target fullText
		includesAttributesOfKind: CtReferenceAttribute
		from: target start
		to: (target stop max: target start)! !

!CtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'remove markup'! !

CtEditCommand subclass: #CtCmdResize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-OB-Commands'!

!CtCmdResize methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute
	
	self textMorph editor resizeMarkup.! !

!CtCmdResize methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!CtCmdResize methodsFor: 'testing' stamp: 'mt 5/3/2009 19:17'!
icon

	^ #ctPaintcanIcon! !

!CtCmdResize methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target start <= target stop
		and: [(target fullText
			attributesOfKind: CtReferenceAttribute
			from: target start
			to: target stop) size = 1]! !

!CtCmdResize methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'resize markup'! !

!CtEditCommand class methodsFor: 'testing' stamp: 'cs 5/2/2009 13:30'!
takesText

	^ true! !

!CtEditCommand methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:31'!
cluster

	^ #CodeTalk! !

!CtEditCommand methodsFor: 'testing' stamp: 'mt 6/23/2009 08:59'!
isActive

	^ target isKindOf: OBTextSelection! !

!CtEditCommand methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target stop >= target start
		and: [(target fullText
			includesAttributesOfKind: CtReferenceAttribute
			from: target start
			to: target stop) not]! !

!CtEditCommand methodsFor: 'execution' stamp: 'mt 6/23/2009 09:52'!
textMorph
	"The requestor has to be an OBEnhancementDefinitionPanel"
	
	^ requestor contentMorph textMorph! !

MultiNewParagraph subclass: #CtParagraph
	instanceVariableNames: 'textMorph showLineNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text'!

!CtParagraph methodsFor: 'displaying-morphs' stamp: 'mt 1/16/2010 17:01'!
addAttributeMorphs
	"Add the small iconmorphs that appear for some attributes in the text."
	
	| morphs |
	self selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].

	morphs := (self text
		attributesOfKind: CtMorphAttribute 
		from: self selectionStart stringIndex
		to: ((self selectionStop stringIndex - 1) max: self selectionStart stringIndex))
		collect: [:attr | self textMorph addMorph: attr morph. attr morph].
	self textMorph removeAllMorphsBut: morphs.! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:00'!
displayOn: aCanvas using: displayScanner at: somePosition

	self
		updateProperties;
		addAttributeMorphs;
		updateAttributeMorphs;
		drawLineNumberBorderOn: aCanvas.
	
	(self lineIndexForPoint: aCanvas clipRect topLeft)
		to: (self lineIndexForPoint: aCanvas clipRect bottomRight)
		do: [ :i |
			self drawTextAttributeOn: aCanvas at: i.
			self drawLineNumber: i on: aCanvas for: (lines at: i)].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:15'!
drawLineNumber: aNumber on: aCanvas for: line

	| str |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	str := (aNumber < 10 ifTrue: [' '] ifFalse: ['']), aNumber asString.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self textMorph position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: ((self isInSelectionFor: line)
			ifTrue: [Color black]
			ifFalse: [Color gray]).! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:12'!
drawLineNumberBorderOn: aCanvas

	| fontWidth |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	fontWidth := Preferences standardCodeFont widthOfString: '99'.
	aCanvas
		line: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect top
		to: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 1/17/2010 14:09'!
drawTextAttributeOn: aCanvas at: index 

	| textLine line nextLine|
	line := lines at: index.
	nextLine := lines size > index ifTrue: [lines at: index + 1] ifFalse: [].
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes |
		attributes 
			select: [:attr | attr isKindOf: CtTextAttribute]
			thenDo: [:attr | | cb1 cb2 |
				cb1 := self characterBlockForIndex: start + (line first - 1).
				cb2 := self characterBlockForIndex: stop + (line first - 1).
	
				"Highlight the attribute."
				attr
					displayOn: aCanvas
					in: (cb1 left @ line top corner: cb2 right @ line bottom).

				(attr isKindOf: CtMorphAttribute) ifTrue: [
					"Update position of the morph from the attribute."
					(self isLastOccuranceOf: attr in: textLine position: stop for: index)
						ifTrue: [self
							moveAttributeMorph: attr morph
							to: cb2 right @ (line top - attr morph height)]]]
				].! !

!CtParagraph methodsFor: 'testing' stamp: 'mt 7/2/2009 21:42'!
isInSelectionFor: line

	(self selectionStart isNil or: [self selectionStop isNil])
		ifTrue: [^ false].
		
	^ line last >= self selectionStart textLine first
		and: [line first <= self selectionStop textLine last]! !

!CtParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 15:31'!
isLastOccuranceOf: cAttr in: textLine position: endOfRunIndex for: lineIndex
	"Answer true if the attribute does not appear in another run past the current one."

	| nextLine |
	nextLine := lines size > lineIndex ifTrue: [lines at: lineIndex + 1] ifFalse: [].
	^ ((nextLine isNil
		or: [((self text attributesAt: nextLine first) noneSatisfy: [:att | att == cAttr])])
		and: [textLine runs size < (endOfRunIndex + 1) 
			or: [(textLine attributesAt: endOfRunIndex + 1)	noneSatisfy: [:att | att == cAttr]]])! !

!CtParagraph methodsFor: 'displaying-morphs' stamp: 'mt 5/3/2009 13:53'!
moveAttributeMorph: aMorph to: aPosition
	"Used to display small morphs to interaction with the markup. Pay attention to the extent of the textMorph if possible."
	
	| pos |
	pos := aPosition.
	self textMorph ifNotNilDo: [:t |
		pos := (t extent x - aMorph width min: aPosition x)
			@ (aPosition y < -5 ifTrue: [aMorph height max: aPosition y] ifFalse: [aPosition y])].
	aMorph position: pos.! !

!CtParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph
	^ textMorph! !

!CtParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph: anObject
	textMorph := anObject! !

!CtParagraph methodsFor: 'displaying-morphs' stamp: 'mt 1/16/2010 17:12'!
updateAttributeMorphs
	
	| attrs |
	self selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].
	
	attrs := self text
		attributesOfKind: CtMorphAttribute 
		from: self selectionStart stringIndex
		to: ((self selectionStop stringIndex - 1) max: self selectionStart stringIndex).

	attrs do: [:attr | attr
		updateMorphs: attrs
		start: self selectionStart stringIndex
		stop: self selectionStop stringIndex].! !

!CtParagraph methodsFor: 'accessing' stamp: 'mt 9/29/2010 15:05:38.598'!
updateProperties

	showLineNumbers ifNil: [showLineNumbers := CtPreferences showLineNumbers].! !

!SHParserST80 methodsFor: '*codetalk' stamp: 'mt 6/6/2009 13:02'!
parseSource: aString
	"Parse the source of a method."

	self
		source: aString;
		parse: true.
	^ ranges! !

Object subclass: #CtAbstractTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtAbstractTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:52:12.276'!
itemKind

	self subclassResponsibility.! !

!CtAbstractTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 16:29:34.373'!
new

	Error signal: 'You must use the other instance creation messages!!'! !

!CtAbstractTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:47:40.419'!
isAvailable

	^ self isProject or: [self item notNil]! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:36:43.861'!
isClass

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:39:42.173'!
isClassComment

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:40:03.911'!
isMethod

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:39:37.681'!
isMethodSource

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:36:02.296'!
isPackage

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:35:57.015'!
isProject

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:39:58.116'!
isProtocol

	^ false! !

!CtAbstractTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:39:15.735'!
isRangeTarget

	^ false! !

!CtAbstractTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 15:36:17.556'!
isSystemCategory

	^ false! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:49:24.266'!
item

	self subclassResponsibility.! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:52:50.955'!
itemKind

	^ self class itemKind! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:45:45.16'!
method

	^ nil! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:46:07.788'!
package

	^ self theClass ifNotNil: [:c | c instanceSide package]! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:56:56.568'!
protocol

	^ self method ifNotNil: [:compiledMethod | compiledMethod methodClass organization categoryOfElement: compiledMethod selector]! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:45:58.463'!
systemCategory

	^ self theClass ifNotNil: [:c | c instanceSide category]! !

!CtAbstractTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:53:02.272'!
theClass

	^ self method ifNotNil: [:compiledMethod | compiledMethod methodClass]! !

CtAbstractTarget subclass: #CtClassTarget
	instanceVariableNames: 'className isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtClassTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 19:45:22.656'!
class: aClass

	^ self basicNew
		initializeClassName: aClass instanceSide name isMeta: aClass isMeta! !

!CtClassTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:53:44.19'!
itemKind

	^ #class! !

!CtClassTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 19:44:48.72'!
initializeClassName: aClassName isMeta: aBoolean

	className ifNotNil: [Error signal: 'You can only initialize this object once!!'].

	className := aClassName.
	isMeta := aBoolean.! !

!CtClassTarget methodsFor: 'testing - entities' stamp: 'mt 9/23/2010 16:33:37.794'!
isClass

	^ true! !

!CtClassTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 16:33:48.704'!
item

	^ self theClass! !

!CtClassTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:44:05.092'!
theClass

	^ isMeta
		ifTrue: [(Smalltalk at: className) class]
		ifFalse: [Smalltalk at: className]! !

CtAbstractTarget subclass: #CtMethodTarget
	instanceVariableNames: 'classTarget selector sourceHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtMethodTarget class methodsFor: 'instance creation' stamp: 'mt 9/28/2010 14:53:14.01'!
class: aClass selector: aSelector

	^ self basicNew
		initializeClass: aClass
		selector: aSelector
		sourceHash: (aClass sourceCodeHashAt: aSelector)! !

!CtMethodTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:53:54.353'!
itemKind

	^ #method! !

!CtMethodTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 17:12:24.457'!
initializeClass: aClass selector: aSelector sourceHash: aHash

	sourceHash ifNotNil: [Error signal: 'You can only initialize this object once!!'].

	classTarget := CtClassTarget class: aClass.
	selector := aSelector.
	sourceHash := aHash.! !

!CtMethodTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:41:45.278'!
isMethod

	^ true! !

!CtMethodTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:49:58.495'!
item

	^ self method! !

!CtMethodTarget methodsFor: 'accessing' stamp: 'mt 9/28/2010 15:12:44.688'!
method

	classTarget isAvailable ifFalse: [^ nil].
	
	^ (self theClass sourceCodeHashAt: selector) = self sourceHash
		ifTrue: [self theClass >> selector]
		ifFalse: [nil]! !

!CtMethodTarget methodsFor: 'accessing - private' stamp: 'mt 9/23/2010 16:28:21.344'!
selector

	^ selector copy! !

!CtMethodTarget methodsFor: 'accessing - private' stamp: 'mt 9/23/2010 16:27:59.299'!
sourceHash

	^ sourceHash! !

!CtMethodTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:13:13.883'!
theClass

	^ classTarget theClass! !

CtAbstractTarget subclass: #CtPackageTarget
	instanceVariableNames: 'packageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtPackageTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:54:07.294'!
itemKind

	^ #package! !

!CtPackageTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 17:00:26.086'!
package: aPackageInfo

	^ self basicNew
		initializePackageName: aPackageInfo name.! !

!CtPackageTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 16:59:07.655'!
packageNamed: aPackageName

	^ self basicNew
		initializePackageName: aPackageName.! !

!CtPackageTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 16:58:08.201'!
initializePackageName: aPackageName

	packageName ifNotNil: [Error signal: 'You can only initialize this object once!!'].
	
	packageName := aPackageName.! !

!CtPackageTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 16:57:09.766'!
isAvailable

	^ PackageOrganizer default packageNames includes: packageName! !

!CtPackageTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:41:52.567'!
isPackage

	^ true! !

!CtPackageTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:50:15.278'!
item

	^ self package! !

!CtPackageTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 16:56:35.06'!
package

	^ PackageOrganizer default packageNamed: packageName ifAbsent: []! !

CtAbstractTarget subclass: #CtProjectTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtProjectTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:54:18.884'!
itemKind

	^ #project! !

!CtProjectTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 20:31:00.342'!
new

	^ self basicNew! !

!CtProjectTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:42:02.838'!
isProject

	^ true! !

CtAbstractTarget subclass: #CtProtocolTarget
	instanceVariableNames: 'classTarget protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtProtocolTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 16:43:56.251'!
class: aClass protocol: aProtocol

	^ self basicNew
		initializeClass: aClass
		protocol: aProtocol! !

!CtProtocolTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:54:30.653'!
itemKind

	^ #protocol! !

!CtProtocolTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 16:43:27.389'!
initializeClass: aClass protocol: aProtocol

	protocol ifNotNil: [Error signal: 'You can only initialize this object once!!'].

	classTarget := CtClassTarget class: aClass.
	protocol := aProtocol.! !

!CtProtocolTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 16:46:35.053'!
isAvailable

	^ classTarget isAvailable
		and: [self theClass organization categories includes: self protocol]! !

!CtProtocolTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:42:11.04'!
isProtocol

	^ true! !

!CtProtocolTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:50:31.745'!
item

	^ self protocol! !

!CtProtocolTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 16:39:51.892'!
protocol

	^ protocol! !

!CtProtocolTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 16:41:55.704'!
theClass

	^ classTarget theClass! !

CtAbstractTarget subclass: #CtRangeTarget
	instanceVariableNames: 'start stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

CtRangeTarget subclass: #CtClassCommentTarget
	instanceVariableNames: 'classTarget commentHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtClassCommentTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 20:50:30.703'!
class: aClass from: aStartIndex to: aStopIndex

	^ (self from: aStartIndex to: aStopIndex)
		initializeClass: aClass
		commentHash: (SecureHashAlgorithm new hashMessage: aClass comment asString)! !

!CtClassCommentTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:54:48.505'!
itemKind

	^ #classComment! !

!CtClassCommentTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 17:29:35.921'!
initializeClass: aClass commentHash: aHash

	commentHash ifNotNil: [Error signal: 'You can only initialize this object once!!'].

	classTarget := CtClassTarget class: aClass.
	commentHash := aHash.! !

!CtClassCommentTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:42:52.959'!
isClassComment

	^ true! !

!CtClassCommentTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:33:25.961'!
item

	classTarget isAvailable ifFalse: [^ nil].
	
	^ (SecureHashAlgorithm new hashMessage: self theClass comment asString) = commentHash
		ifTrue: [self theClass comment]! !

!CtClassCommentTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 20:35:28.013'!
theClass

	^ classTarget theClass! !

CtRangeTarget subclass: #CtMethodSourceTarget
	instanceVariableNames: 'methodTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtMethodSourceTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 17:39:04.274'!
class: aClass selector: aSelector from: aStartIndex to: aStopIndex

	^ (self from: aStartIndex to: aStopIndex)
		initializeClass: aClass
		selector: aSelector! !

!CtMethodSourceTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:55:13.807'!
itemKind

	^ #methodSource! !

!CtMethodSourceTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 17:38:15.83'!
initializeClass: aClass selector: aSelector

	methodTarget ifNotNil: [Error signal: 'You can only initialize this object once!!'].

	methodTarget := CtMethodTarget class: aClass selector: aSelector.! !

!CtMethodSourceTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:43:10.584'!
isMethodSource

	^ true! !

!CtMethodSourceTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:41:01.342'!
item

	^ self method! !

!CtMethodSourceTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:36:47.557'!
method

	^ methodTarget method! !

!CtMethodSourceTarget methodsFor: 'accessing' stamp: 'mt 9/28/2010 15:12:07.911'!
selector

	^ methodTarget selector! !

!CtMethodSourceTarget methodsFor: 'accessing' stamp: 'mt 9/28/2010 15:09:43.545'!
sourceHash

	^ methodTarget sourceHash! !

!CtMethodSourceTarget methodsFor: 'accessing' stamp: 'mt 9/28/2010 15:12:15.486'!
theClass

	^ methodTarget theClass! !

!CtRangeTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 17:23:31.648'!
from: startInteger to: stopInteger

	^ self basicNew
		initializeFrom: startInteger
		to: stopInteger! !

!CtRangeTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 17:24:37.879'!
initializeFrom: startInteger to: stopInteger

	start ifNotNil: [Error signal: 'You can only initialize this object once!!'].
	
	start := startInteger.
	stop := stopInteger.! !

!CtRangeTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:42:44.924'!
isRangeTarget

	^ true! !

!CtRangeTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:25:02.353'!
startIndex

	^ start! !

!CtRangeTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:25:07.115'!
stopIndex

	^ stop! !

CtAbstractTarget subclass: #CtSystemCategoryTarget
	instanceVariableNames: 'systemCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtSystemCategoryTarget class methodsFor: 'accessing' stamp: 'mt 9/23/2010 19:55:24.477'!
itemKind

	^ #systemCategory! !

!CtSystemCategoryTarget class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 16:50:53.477'!
systemCategory: aSystemCategory

	^ self basicNew
		initializeSystemCategory: aSystemCategory! !

!CtSystemCategoryTarget methodsFor: 'initialization' stamp: 'mt 9/23/2010 16:49:19.945'!
initializeSystemCategory: aSystemCategory

	systemCategory ifNotNil: [Error signal: 'You can only initialize this object once!!'].
	
	systemCategory := aSystemCategory.! !

!CtSystemCategoryTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 16:53:22.769'!
isAvailable

	^ SystemOrganization categories includes: self systemCategory! !

!CtSystemCategoryTarget methodsFor: 'testing' stamp: 'mt 9/23/2010 15:43:19.026'!
isSystemCategory

	^ true! !

!CtSystemCategoryTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:50:56.686'!
item

	^ self systemCategory! !

!CtSystemCategoryTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 16:54:45.906'!
package

	^ PackageOrganizer default
		packageOfSystemCategory: self systemCategory
		ifNone: []! !

!CtSystemCategoryTarget methodsFor: 'accessing' stamp: 'mt 9/23/2010 16:48:42.648'!
systemCategory

	^ systemCategory! !

Object subclass: #CtCodeChatModel
	instanceVariableNames: 'attribute searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Editor'!

!CtCodeChatModel methodsFor: 'adding' stamp: 'mt 3/2/2010 11:48:17'!
addMessage: aMessage

	aMessage ifEmpty: [^ self].
	self attribute ifNil: [^ self].
	self attribute addChatLine: aMessage.
	self
		changed: #messages;
		changed: #newMessage;
		changed: #hasMessages.! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute

	^ attribute! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 9/27/2010 11:50:33.718'!
attribute: aMarkupReferenceAttribute

	attribute := aMarkupReferenceAttribute.
	self changed: #messages.! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:14'!
hasMessages

	^ self attribute notNil and: [self attribute chat isEmpty not].! !

!CtCodeChatModel methodsFor: 'adding' stamp: 'mt 3/2/2010 11:58:09'!
highlight: aText ifMatch: aString
	"Change backgroundcolor if the string is in the message."
	
"	(aText asString asLowercase includesSubString: aString asLowercase)
		ifTrue: [self color: Color yellow]."! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 9/28/2010 15:27:32.368'!
messages

	self attribute ifNil: [^ '' asText].
	
	^ self attribute chat
		inject: Text new
		into: [:result :line |
			| author timestamp message entry |
			author := line author asText.
			author
				addAttribute: TextEmphasis bold
				";FIXME: fonts
                                addAttribute: (TextFontReference toFont: (CtFontProvider sansFontAt: 8))".
			timestamp := line timestamp printRelativeTimeStamp asText.
			timestamp
				addAttribute: TextColor gray
                                ";FIXME: fonts
				addAttribute: (TextFontReference toFont: (CtFontProvider sansFontAt: 8))".
			message := line text asText.
			message addAttribute: (TextIndent amount: 1).
			CtMethodLink addMethodLinksInto: message.
			CtLoader highlightAuthorInitialsFor: message.
			self highlight: message ifMatch: self searchString.
			
			result
				append: author;
				append: '  ';
				append: timestamp;
				append: String cr;
				append: message;
				append: String cr.
			].! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:07'!
newMessage

	^ ''! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 13:58'!
searchString

	searchString ifNil: [searchString := ''].
	^ searchString! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:21'!
searchString: aString

	searchString := aString.
	self changed: #messages.! !

Object subclass: #CtLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Core'!

!CtLoader commentStamp: 'mt 3/2/2010 10:51:58' prior: 0!
This class is only for general CodeTalk initialization purposes. See the class-side methods.!

!CtLoader class methodsFor: 'services' stamp: 'mt 3/2/2010 11:53:56'!
highlightAuthorInitialsFor: aText
	"Look for this image's author initials and highlight them. This will modify the attributse of the given text."
	
	| rx s strm links |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 1.
				rx subEnd: 1}].

	links do: [:link |
		aText
			addAttribute: (TextColor color: Color green muchDarker)
			from: link first + 1
			to: link second.
		aText
			addAttribute: TextEmphasis bold
			from: link first + 1
			to: link second].
		
	^ aText! !

!CtLoader class methodsFor: 'initialization' stamp: 'mt 9/27/2010 11:39:05.426'!
initialize
	"Resend this message whenever you checkout a new version of CodeTalk."
	
	super initialize.
	self
		initializePreferences;
		initializeOtherClasses.
	
	"Setup a global variable that holds all markups for this image."
	Smalltalk at: #SystemMarkups ifAbsentPut: CtMarkupDatabase new.! !

!CtLoader class methodsFor: 'initialization' stamp: 'mt 9/28/2010 15:25:02.772'!
initializeOtherClasses
	
	(Smalltalk includesKey: #CtEditor)
		ifTrue: [CtEditor initializeCmdKeyShortcuts].
		
	((Smalltalk includesKey: #SwaSourceTextStyler)
	and: [(Smalltalk includesKey: #CtSourceTextStyler)])
		ifTrue: [SwaSourceTextStyler instance registeredStylers
			detect: [:styler | styler isKindOf: CtSourceTextStyler]
			ifNone: [SwaSourceTextStyler instance registerStyler: (CtSourceTextStyler new)]].
		
	(OBDefinitionPanel allInstVarNames includes: #contentMorph)
		ifFalse:[OBDefinitionPanel addInstVarName: #contentMorph].! !

!CtLoader class methodsFor: 'initialization' stamp: 'mt 9/29/2010 15:17:47.17'!
initializePreferences

	Preferences setPreference: #confirmFirstUseOfStyle toValue: false.
	Preferences setPreference: #alwaysShowVScrollbar toValue: false.! !

Object subclass: #CtMarkup
	instanceVariableNames: 'uuid talk author timestamp anchestor tags targets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtMarkup class methodsFor: 'color mapping' stamp: 'mt 9/27/2010 14:32:02.057'!
colorForTags: someTags

	(someTags includes: #bad)
		ifTrue: [^ Color red alpha: 0.4].
		
	(someTags includes: #talk)
		ifTrue: [^ Color yellow alpha: 0.4].
		
	(someTags includes: #comment)
		ifTrue: [^ Color green alpha: 0.4].
		
	^ Color transparent! !

!CtMarkup methodsFor: 'comparing' stamp: 'mt 9/29/2010 14:21:41.01'!
= anotherMarkup

	^ self uuid = anotherMarkup uuid! !

!CtMarkup methodsFor: 'anchestry' stamp: 'mt 9/23/2010 14:45:49.129'!
anchestor

	^ anchestor "uuid"! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/23/2010 14:30:14.32'!
author

	^ author copy! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/27/2010 11:46:39.325'!
color

	^ self class colorForTags: tags! !

!CtMarkup methodsFor: 'copying - private' stamp: 'mt 9/23/2010 15:11:41.147'!
copy

	^ super copy	
		initializeAnchestor: self uuid! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/23/2010 15:27:05.233'!
copyWithTagAdded: aSymbol

	| instance |
	instance := self copy.
	instance instVarNamed: #tags put: (tags copyWith: aSymbol).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/27/2010 13:01:02.092'!
copyWithTagChangedFrom: oldTag to: newTag

	| instance |
	instance := self copy.
	instance instVarNamed: #tags put: (tags copy replace: [:tag | tag = oldTag ifTrue: [newTag] ifFalse: [tag]]).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/23/2010 15:27:12.267'!
copyWithTagRemoved: aSymbol

	| instance |
	instance := self copy.
	instance instVarNamed: #tags put: (tags copyWithout: aSymbol).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/27/2010 11:26:30.912'!
copyWithTalkMessageAdded: aTalkMessage

	| instance |
	instance := self copy.
	instance instVarNamed: #talk put: (talk copyWith: aTalkMessage).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/27/2010 11:26:38.473'!
copyWithTalkMessageRemoved: aTalkMessage

	| instance |
	instance := self copy.
	instance instVarNamed: #talk put: (talk copyWithout: aTalkMessage).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/23/2010 17:44:56.169'!
copyWithTargetAdded: aTarget

	| instance |
	instance := self copy.
	instance instVarNamed: #targets put: (targets copyWith: aTarget).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/24/2010 09:46:11.287'!
copyWithTargetChangedFrom: oldTarget to: newTarget

	| instance |
	instance := self copy.
	instance instVarNamed: #targets put: (targets copy replace: [:target | target = oldTarget ifTrue: [newTarget] ifFalse: [target]]).
	^ instance! !

!CtMarkup methodsFor: 'copying' stamp: 'mt 9/23/2010 17:45:14.37'!
copyWithTargetRemoved: aTarget

	| instance |
	instance := self copy.
	instance instVarNamed: #targets put: (targets copyWithout: aTarget).
	^ instance! !

!CtMarkup methodsFor: 'comparing' stamp: 'mt 9/29/2010 14:22:09.453'!
hash

	^ self uuid hash! !

!CtMarkup methodsFor: 'initialization' stamp: 'mt 9/27/2010 11:25:47.234'!
initialize

	super initialize.
	
	uuid := UUID new.
	author := Utilities authorInitials.
	timestamp := TimeStamp now.
	talk := Array new.
	tags := Array new.
	targets := Array new.! !

!CtMarkup methodsFor: 'initialization' stamp: 'mt 9/23/2010 14:47:06.811'!
initializeAnchestor: aUUID

	anchestor ifNotNil: [Error signal: 'You can only set the anchestor once!!'].
	anchestor := aUUID.! !

!CtMarkup methodsFor: 'testing' stamp: 'mt 9/29/2010 15:53:52.134'!
isAuthorMentioned
	"Look into the talk messages to find out if this image's author is mentioned in a message."
	
	| rx |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	^ self talk anySatisfy: [:msg | rx search: msg text asString]! !

!CtMarkup methodsFor: 'testing' stamp: 'mt 9/29/2010 15:53:02.485'!
isMine

	^ self author = Utilities authorInitials! !

!CtMarkup methodsFor: 'copying - private' stamp: 'mt 9/23/2010 14:54:00.637'!
postCopy

	anchestor := nil.
	uuid := UUID new.! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/23/2010 15:27:22.287'!
tags

	^ tags copy! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/23/2010 14:30:18.955'!
talk

	^ talk copy! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/23/2010 17:44:22.338'!
targets

	^ targets copy! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/23/2010 14:25:11.719'!
timestamp

	^ timestamp! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 9/23/2010 14:24:51.906'!
uuid

	^ uuid! !

Object subclass: #CtMarkupDatabase
	instanceVariableNames: 'activeMarkups inactiveMarkups tags properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtMarkupDatabase methodsFor: 'add/remove' stamp: 'mt 9/28/2010 14:34:53.802'!
addMarkup: aMarkup
	
	self ignoresMarkupAdd ifTrue: [^ aMarkup].
	
	(activeMarkups includesKey: aMarkup uuid)
		ifTrue: ["Already there." ^ aMarkup].
	
	(inactiveMarkups includesKey: aMarkup uuid)
		ifTrue: [Error signal: 'You cannot add an inactive markup!!'].
	
	"If an anchestor is set, the corresponding markup MUST BE in the active list."
	(aMarkup anchestor isNil or: [activeMarkups includesKey: aMarkup anchestor])
		ifFalse: [Error signal:'The anchestor WAS NOT found in the active markups list!!'].

	"Store the tags used."
	tags addAll: aMarkup tags.

	activeMarkups at: aMarkup uuid put: aMarkup.

	aMarkup anchestor ifNil: [
		SystemChangeNotifier uniqueInstance markupAdded: aMarkup.
		^ aMarkup].

	"Deactivate."
	self makeInactive: (activeMarkups at: aMarkup anchestor).
	
	SystemChangeNotifier uniqueInstance
		markupChangedFrom: (inactiveMarkups at: aMarkup anchestor)
		to: aMarkup.
		
	^ aMarkup! !

!CtMarkupDatabase methodsFor: 'properties' stamp: 'mt 9/28/2010 14:26:05.136'!
allowQueries

	properties at: #allowQueries put: true.! !

!CtMarkupDatabase methodsFor: 'queries - anchestry' stamp: 'mt 9/24/2010 10:09:47.023'!
anchestryForMarkup: aMarkup

	| m result |
	m := aMarkup.
	result := OrderedCollection new. 
	[m anchestor notNil] whileTrue: [
		result add: (m := inactiveMarkups at: m anchestor)].
	^ result
	! !

!CtMarkupDatabase methodsFor: 'snapshot handling' stamp: 'mt 9/27/2010 11:08:27.121'!
createSnapshot: aPackageName
	"Copy that part of the database that belongs to the package specified by the given name."

	| active inactive |	
	active := self markupsForPackageNamed: aPackageName.
	inactive := active
		inject: OrderedCollection new
		into: [:all :activeMarkup | all addAll: (self anchestryForMarkup: activeMarkup). all].
		
	^ CtMarkupDatabaseSnapshot
		packageName: aPackageName
		activeMarkups: active
		inactiveMarkups: inactive! !

!CtMarkupDatabase methodsFor: 'properties' stamp: 'mt 9/28/2010 14:26:15.352'!
denyQueries

	properties at: #allowQueries put: false.! !

!CtMarkupDatabase methodsFor: 'properties - testing' stamp: 'mt 9/28/2010 14:28:28.617'!
ignoresMarkupAdd

	^ (properties at: #allowMarkupAdd ifAbsent: [true]) not! !

!CtMarkupDatabase methodsFor: 'properties - testing' stamp: 'mt 9/28/2010 14:28:36.981'!
ignoresMarkupRemove

	^ (properties at: #allowMarkupRemove ifAbsent: [true]) not! !

!CtMarkupDatabase methodsFor: 'properties - testing' stamp: 'mt 9/28/2010 14:28:32.89'!
ignoresQueries

	^ (properties at: #allowQueries ifAbsent: [true]) not! !

!CtMarkupDatabase methodsFor: 'initialization' stamp: 'mt 9/28/2010 14:24:13.171'!
initialize

	super initialize.
	
	properties := Dictionary new.
	activeMarkups := Dictionary new.
	inactiveMarkups := Dictionary new.
	tags := #(talk bad comment) asSet.! !

!CtMarkupDatabase methodsFor: 'testing' stamp: 'mt 9/23/2010 18:50:01.571'!
isEmpty

	^ activeMarkups isEmpty! !

!CtMarkupDatabase methodsFor: 'snapshot handling' stamp: 'mt 9/27/2010 11:22:07.026'!
loadSnapshot: aMarkupDatabaseSnapshot
	"Load all markups into the receiver. Local ones will be discarded."
	
	(self markupsForPackageNamed: aMarkupDatabaseSnapshot packageName)
		do: [:markup | self removeMarkupWithAnchestry: markup].
		
	aMarkupDatabaseSnapshot activeMarkups do: [:m |
		activeMarkups at: m uuid put: m.
		inactiveMarkups removeKey: m uuid ifAbsent: []].
	aMarkupDatabaseSnapshot inactiveMarkups do: [:m |
		inactiveMarkups at: m uuid put: m.
		activeMarkups removeKey: m uuid ifAbsent: []].! !

!CtMarkupDatabase methodsFor: 'properties' stamp: 'mt 9/28/2010 14:25:48.687'!
lock

	properties at: #allowQueries put: false.
	properties at: #allowMarkupAdd put: false.
	properties at: #allowMarkupRemove put: false.! !

!CtMarkupDatabase methodsFor: 'add/remove - private' stamp: 'mt 9/26/2010 14:32:39.593'!
makeInactive: aMarkup

	"Move anchestor to inactive list."
	inactiveMarkups
		at: aMarkup uuid
		put: aMarkup.
	activeMarkups removeKey: aMarkup uuid.! !

!CtMarkupDatabase methodsFor: 'queries - private' stamp: 'mt 9/28/2010 14:30:34.279'!
markupsFor: anObject kind: targetKind property: targetProperty

	self ignoresQueries ifTrue: [^ #()].

	^ activeMarkups values select: [:markup | markup targets anySatisfy: [:target |
		target itemKind = targetKind and: [(target perform: targetProperty) = anObject]]].! !

!CtMarkupDatabase methodsFor: 'queries' stamp: 'mt 9/28/2010 14:29:58.473'!
markupsForClass: aClass kind: targetKind

	^ self markupsFor: aClass kind: targetKind property: #theClass! !

!CtMarkupDatabase methodsFor: 'queries' stamp: 'mt 9/28/2010 14:29:50.149'!
markupsForClass: aClass protocol: aProtocol kind: targetKind

	self ignoresQueries ifTrue: [^ #()].

	^ activeMarkups values select: [:markup | markup targets anySatisfy: [:target |
		target itemKind = targetKind
			and: [target theClass = aClass]
			and: [target protocol = aProtocol]]]! !

!CtMarkupDatabase methodsFor: 'queries' stamp: 'mt 9/23/2010 20:09:00.565'!
markupsForClass: aClass selector: aSelector kind: targetKind

	^ self markupsFor: aClass >> aSelector kind: targetKind property: #method! !

!CtMarkupDatabase methodsFor: 'queries - anchestry' stamp: 'mt 9/28/2010 16:32:42.539'!
markupsForClass: aClass selector: aSelector sourceHash: aHash
	"Useful for retrieving markups for old method versions."

	| candidates result |
	self ignoresQueries ifTrue: [^ #()].

	"Step 1 - Select all markups that would theoretically match the query."
	candidates := activeMarkups values, inactiveMarkups values select: [:markup |
		markup targets anySatisfy: [:target |
			target isMethodSource
				and: [target theClass = aClass]
				and: [target selector = aSelector]	
				and: [target sourceHash = aHash]]].
		
	"Step 2 - Filter the youngest markups in anchestry."
	result := candidates copy asOrderedCollection.
	candidates do: [:markup |
		| m |
		m := markup.
		[(m := inactiveMarkups at: m anchestor ifAbsent: []) notNil] whileTrue: [
			result remove: m ifAbsent: []]].
	
	^ result! !

!CtMarkupDatabase methodsFor: 'queries' stamp: 'mt 9/23/2010 20:07:09.139'!
markupsForPackage: aPackageInfo kind: targetKind

	^ self markupsFor: aPackageInfo kind: targetKind property: #package! !

!CtMarkupDatabase methodsFor: 'queries - generic' stamp: 'mt 9/28/2010 14:30:12.643'!
markupsForPackageNamed: aPackageName

	self ignoresQueries ifTrue: [^ #()].

	^ activeMarkups values select: [:markup | markup targets anySatisfy: [:target |
		target package name = aPackageName]]! !

!CtMarkupDatabase methodsFor: 'queries' stamp: 'mt 9/23/2010 20:07:41.096'!
markupsForPackageNamed: aPackageName kind: targetKind

	^ self markupsForPackage: (PackageInfo named: aPackageName) kind: targetKind! !

!CtMarkupDatabase methodsFor: 'queries' stamp: 'mt 9/23/2010 20:15:33.214'!
markupsForSystemCategory: aSystemCategory kind: targetKind

	^ self markupsFor: aSystemCategory kind: targetKind property: #systemCategory! !

!CtMarkupDatabase methodsFor: 'queries - generic' stamp: 'mt 9/28/2010 14:30:17.09'!
markupsOfKind: targetKind

	self ignoresQueries ifTrue: [^ #()].

	^ activeMarkups values select: [:markup | markup targets anySatisfy: [:target |
		target itemKind = targetKind]]! !

!CtMarkupDatabase methodsFor: 'snapshot handling' stamp: 'mt 9/27/2010 11:21:05.455'!
mergeSnapshot: aMarkupDatabaseSnapshot
	"TODO!!!!!! Merges all markups into the receiver."
	
	| relevantActiveMarkups |
	Error signal: 'This method should not be used.'.
	
	relevantActiveMarkups := self markupsForPackageNamed: aMarkupDatabaseSnapshot packageName.
	
	"Remove local markups that are deprecated."
	relevantActiveMarkups
		select: [:m |
			"Markups that got inactive in the snapshot but are active in local database."
			(aMarkupDatabaseSnapshot includesInactive: m) or: [
			"Markups that were removed completely."
			(aMarkupDatabaseSnapshot includesActive: m) not and: [
				m timestamp <= aMarkupDatabaseSnapshot timestamp]]]
		thenDo: [:m | self removeMarkupWithAnchestry: m].
		
	"Add new markups."
	aMarkupDatabaseSnapshot activeMarkups do: [:m |
		activeMarkups at: m uuid put: m].
	aMarkupDatabaseSnapshot inactiveMarkups do: [:m |
		inactiveMarkups at: m uuid put: m].! !

!CtMarkupDatabase methodsFor: 'add/remove' stamp: 'mt 9/28/2010 14:31:25.624'!
removeMarkup: aMarkup

	self ignoresMarkupRemove ifTrue: [^ aMarkup].

	(activeMarkups includesKey: aMarkup uuid)
		ifFalse: [Error signal: 'You can only remove an active markup!!'].
		
	self makeInactive: aMarkup.
	
	SystemChangeNotifier uniqueInstance markupRemoved: aMarkup.! !

!CtMarkupDatabase methodsFor: 'add/remove' stamp: 'mt 9/26/2010 19:29:41.984'!
removeMarkupWithAnchestry: aMarkup

	| anchestor |
	(activeMarkups includesKey: aMarkup uuid)
		ifFalse: [Error signal: 'You can only remove an active markup!!'].
		
	activeMarkups removeKey: aMarkup uuid.
	anchestor := aMarkup anchestor.
	
	[anchestor notNil] whileTrue: [
		| m |
		m := (inactiveMarkups at: anchestor).
		inactiveMarkups removeKey: m uuid.
		anchestor := m anchestor].! !

!CtMarkupDatabase methodsFor: 'accessing' stamp: 'mt 9/27/2010 12:06:51.684'!
tags
	"Return a list of all tags that where used in markups."
	
	^ tags copy! !

!CtMarkupDatabase methodsFor: 'properties' stamp: 'mt 9/28/2010 14:26:35.489'!
unlock

	properties at: #allowQueries put: true.
	properties at: #allowMarkupAdd put: true.
	properties at: #allowMarkupRemove put: true.! !

CtMarkupDatabase subclass: #CtMarkupDatabaseSnapshot
	instanceVariableNames: 'packageName timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtMarkupDatabaseSnapshot class methodsFor: 'instance creation' stamp: 'mt 9/26/2010 19:25:12.202'!
packageName: aPackageName activeMarkups: someActiveMarkups inactiveMarkups: someInactiveMarkups

	^ self new
		initializePackageName: aPackageName
		activeMarkups: someActiveMarkups
		inactiveMarkups: someInactiveMarkups! !

!CtMarkupDatabaseSnapshot methodsFor: 'accessing' stamp: 'mt 9/24/2010 10:38:17.327'!
activeMarkups

	^ activeMarkups! !

!CtMarkupDatabaseSnapshot methodsFor: 'accessing' stamp: 'mt 9/24/2010 10:38:21.791'!
inactiveMarkups

	^ inactiveMarkups! !

!CtMarkupDatabaseSnapshot methodsFor: 'testing' stamp: 'mt 9/26/2010 13:14:29.762'!
includesActive: aMarkup

	^ activeMarkups anySatisfy: [:m | m uuid = aMarkup uuid]	! !

!CtMarkupDatabaseSnapshot methodsFor: 'testing' stamp: 'mt 9/26/2010 13:15:49.523'!
includesInactive: aMarkup

	^ inactiveMarkups anySatisfy: [:m | m uuid = aMarkup uuid]	! !

!CtMarkupDatabaseSnapshot methodsFor: 'initialization' stamp: 'mt 9/26/2010 19:26:17.308'!
initializePackageName: aPackageName activeMarkups: someActiveMarkups inactiveMarkups: someInactiveMarkups

	timestamp ifNotNil: [Error signal: 'This object can only be initialized once!!'].

	packageName := aPackageName.
	timestamp := TimeStamp now.
	
	someActiveMarkups do: [:activeMarkup |
		activeMarkups at: activeMarkup uuid put: activeMarkup].
	
	someInactiveMarkups do: [:inactiveMarkup |
		inactiveMarkups at: inactiveMarkup uuid put: inactiveMarkup].! !

!CtMarkupDatabaseSnapshot methodsFor: 'accessing' stamp: 'mt 9/24/2010 10:38:49.07'!
packageName

	^ packageName! !

!CtMarkupDatabaseSnapshot methodsFor: 'accessing' stamp: 'mt 9/26/2010 19:23:28.039'!
timestamp

	^ timestamp! !

Object subclass: #CtMarkupGenerator
	instanceVariableNames: 'markup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtMarkupGenerator commentStamp: 'mt 9/27/2010 13:48:35.885' prior: 0!
Generate new markups, configure details and get a markup that has no anchestor (i.e. is considered as a new one).!

!CtMarkupGenerator methodsFor: 'configuration' stamp: 'mt 9/27/2010 13:47:06.447'!
addTag: aSymbol

	markup := markup copyWithTagAdded: aSymbol.! !

!CtMarkupGenerator methodsFor: 'configuration' stamp: 'mt 9/27/2010 13:47:32.715'!
addTalkMessage: aMessage

	markup := markup copyWithTalkMessageAdded: aMessage.! !

!CtMarkupGenerator methodsFor: 'configuration' stamp: 'mt 9/27/2010 13:46:16.682'!
addTarget: aTarget

	markup := markup copyWithTargetAdded: aTarget.! !

!CtMarkupGenerator methodsFor: 'initialization' stamp: 'mt 9/27/2010 13:47:59.865'!
initialize

	super initialize.
	markup := CtMarkup new.! !

!CtMarkupGenerator methodsFor: 'accessing' stamp: 'mt 9/27/2010 13:46:44.167'!
next

	| result |
	(markup instVarNamed: #anchestor put: nil).
	result := markup.
	markup := CtMarkup new.
	^ result! !

Object subclass: #CtPreferences
	instanceVariableNames: ''
	classVariableNames: 'ShowLineNumbers ShowProtocolForMethod'
	poolDictionaries: ''
	category: 'CodeTalk-Core'!

!CtPreferences class methodsFor: 'accessing' stamp: 'mt 9/29/2010 15:18:51.752'!
showLineNumbers

	<preference: 'Show line numbers in code editor'
		category: 'CodeTalk'
		description: 'Shows lines numbers in the OmniBrowser code definition panel in the bottom half of the browser.'
		type: #Boolean>
		
	^ ShowLineNumbers ifNil: [false]! !

!CtPreferences class methodsFor: 'accessing' stamp: 'mt 9/29/2010 15:16:09.5'!
showLineNumbers: aBoolean

	ShowLineNumbers := aBoolean.! !

!CtPreferences class methodsFor: 'accessing' stamp: 'mt 9/29/2010 15:22:42.077'!
showProtocolForMessage

	<preference: 'Show protocol in message list'
		category: 'CodeTalk'
		description: 'Shows the corresponding protocol behind the selector in the message list in the OmniBrowser.'
		type: #Boolean>
		
	^ ShowProtocolForMethod ifNil: [false]
! !

!CtPreferences class methodsFor: 'accessing' stamp: 'mt 9/29/2010 15:16:24.912'!
showProtocolForMessage: aBoolean

	ShowProtocolForMethod := aBoolean.
! !

Object subclass: #CtSourceTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Text'!

!CtSourceTextStyler commentStamp: 'mt 1/17/2010 12:29' prior: 0!
I can be used by the SwaSourceTextStyler.!

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 9/29/2010 10:03:06.423'!
styleSource: aText inClass: aClass selector: aSelector
	"This approach does only work for the current version of a method."

	aClass ifNil: [^ aText].

	self
		styleSource: aText
		markups: (SystemMarkups
			markupsForClass: aClass
			selector: aSelector
			kind: #methodSource)
		inClass: aClass
		selector: aSelector.
		
	^ aText! !

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 9/28/2010 12:33:46.793'!
styleSource: aText markup: aMarkup inClass: aClass selector: aSelector

	| ref bg target |
	ref := CtReferenceAttribute forMarkup: aMarkup.
	ref theClass: aClass; selector: aSelector. "Needed for later database lookup."

	"Should only be one method source target yet."
	target := aMarkup targets detect: [:t | t isMethodSource].
	
	aText
		addAttribute: ref
		from: target startIndex
		to: target stopIndex
		guarded: true.

	aText
		addAttribute: (CtIconBarAttribute forReference: ref)
		from: target startIndex
		to: target stopIndex
		guarded: true.

	bg := CtTextBackgroundColor color: ref color.
	aText
		addAttribute: bg
		from: target startIndex
		to: target stopIndex
		guarded: true.
	ref addFriend: bg.! !

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/17/2010 16:05'!
styleSource: aText markups: someMarkups inClass: aClass selector: aSelector

	someMarkups do: [:markup |
		self
			styleSource: aText
			markup: markup
			inClass: aClass
			selector: aSelector]! !

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 9/29/2010 09:52:42.681'!
styleSource: aText of: aCompiledMethod
	"This approach does only work for the current version of a method."

	aCompiledMethod ifNil: [^ aText].
	
	self
		styleSource: aText
		inClass: aCompiledMethod methodClass
		selector: aCompiledMethod selector.
		
	^ aText! !

Object subclass: #CtTalkMessage
	instanceVariableNames: 'timestamp author text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Model'!

!CtTalkMessage commentStamp: 'mt 9/23/2010 13:50:49.075' prior: 0!
Instances of this class are immutable.!

!CtTalkMessage class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 13:50:31.649'!
new

	Error signal: 'You must use #text: to create a new talk message!!'.! !

!CtTalkMessage class methodsFor: 'instance creation' stamp: 'mt 9/23/2010 13:52:23.434'!
text: aText

	^ super new initializeText: aText! !

!CtTalkMessage methodsFor: 'accessing' stamp: 'mt 9/23/2010 13:55:31.672'!
author

	^ author copy! !

!CtTalkMessage methodsFor: 'initialization' stamp: 'mt 9/23/2010 13:52:05.056'!
initialize

	super initialize.
	
	author := Utilities authorInitials.
	timestamp := TimeStamp now.! !

!CtTalkMessage methodsFor: 'initialization' stamp: 'mt 9/23/2010 14:48:09.347'!
initializeText: aText

	text ifNotNil: [Error signal: 'A talk message is immutable!!'].
	text := aText.! !

!CtTalkMessage methodsFor: 'accessing' stamp: 'mt 9/23/2010 13:55:35.932'!
text

	^ text copy! !

!CtTalkMessage methodsFor: 'accessing' stamp: 'mt 9/23/2010 13:42:34.666'!
timestamp

	^ timestamp! !
CtLoader initialize!
